#include "definitions.h"


float Time = FLT_MAX;

int verify_conditions(int x[MATRIX_WIDTH][MATRIX_WIDTH], int N, int M, int *widtharray)
{
	int i,j;
	int OK = 1;
	int sum = 0;
	int count = 0;

	/* Condizioni Verticali */
/*	i = 0;
	while ( (i < N) && OK )
	{
		for (j = 0, sum = 0; j < M; j++)
		{
			sum += x[i][j];
		}
		if (widtharray[i] != sum) OK = 0;
		i++;
	}
*/
	/* Condizioni orizzontali */
	for (j=0; ((j<M) && OK ); j++)
	{
		count = 0;
		for (i=0; i<N; i++)
			if (x[i][j]) count++;
		if (count>1) OK = 0;
	}


	return OK;
}

float compute_time(int x[MATRIX_WIDTH][MATRIX_WIDTH], int N, int M,
				   int *widtharray, SLAVE *slavearray, RECTANGLE *rectanglearray)
{
	float *OH;
	float *TimeArray;
	float Time;
	int ampiezza_colonna;
	int i,j;

	/* Per prima cosa calcolo gli M overhead */
	OH = malloc( M * sizeof(float) );
	memset(OH, 0, sizeof(float)*M );
	TimeArray = malloc( M * sizeof(float) );
	memset(TimeArray, 0, sizeof(float)*M );


	for (j=0; j<M; j++)
	{
		/*OH[j] = ( OH_CONST + filelist_size( (rectanglearray[j].req)->files ) / OH_NETSPEED )
		          + ( j==0 ? 0 : OH[j-1] );*/
		OH[j] = OH_CONST + (j==0 ? (float) 0 : OH[j-1]);
	}

	ampiezza_colonna = rectanglearray[0].y2 - rectanglearray[0].y1 + 1;
	
	for (j=0; j<M; j++)
	{
		TimeArray[j] = OH[j];
		
		for (i=0; i<N; i++)
		{
			TimeArray[j] += x[i][j] * ampiezza_colonna / slavearray[j].power;
		} 
	}

	Time = TimeArray[0];
	for (j=1; j<M; j++)
	{
		if (TimeArray[j]>Time) Time = TimeArray[j];
	}

	
	free(OH);
	free(TimeArray);
	return Time;
}


#define CreaMatriceAllocazione cycle_matrix4
unsigned long int cycle_matrix4(int x[MATRIX_WIDTH][MATRIX_WIDTH], int line, int N, int M, int *widtharray,
				  int out[MATRIX_WIDTH][MATRIX_WIDTH], SLAVE *slavearray, RECTANGLE *rectanglearray)
{
	int i,j,w, k;
	int *sum;
	
	float CurrentTime;
	int limit_not_reached = 1;
	
	
	
	if (line==0)
	{
		i = N-1;
		j = 0;

		sum = malloc( N*sizeof(int) );
		memset(sum, 0, N*sizeof(int) );
		
		while (i>=0)
		{
			for (k=M-1; k>0; k--)
				sum[i] += x[i][k];

			
			if ( (widtharray[i]-sum[i]) < 0 ) limit_not_reached = 0;
			
			i--;
		}

		
		if (limit_not_reached)
		{
			i = N-1;
			while (i>=0)
			{
				x[i][j] = widtharray[i] - sum[i];
				i--;
			}
			free(sum);

			if ( verify_conditions(x, N,M, widtharray) )
			{
				CurrentTime = compute_time(x, N,M, widtharray, slavearray, rectanglearray);
				if (CurrentTime < Time)
				{
					Time = CurrentTime;
					memcpy(out, x, MATRIX_WIDTH*MATRIX_WIDTH*sizeof(int) );
				}
			}

			i = N-1;
			while (i>=0)
			{
				x[i][j] = 0;
				i--;
			}
		}
		
		
	}
	else
	{
		i = N-1;
		j = line;

		while (i>=0)
		{
			while( x[i][j] <= widtharray[i] )
			{
				cycle_matrix4(x, line-1,   N, M, widtharray, out, slavearray, rectanglearray);
				
				if (x[i][j]==widtharray[i]) break; 

				x[i][j] += STEP;
				w = widtharray[i];
				if (x[i][j] > w) x[i][j] = w;
			}
			x[i][j] = 0;
			i--;
		}
	}

	return 0;

}


int main2()
{
	SLAVE *slavearray;
	RECTANGLE *rectanglearray;
	int *widtharray;

	int N = 2;
	int M = 5;
	int x[MATRIX_WIDTH][MATRIX_WIDTH];
	int out[MATRIX_WIDTH][MATRIX_WIDTH];
	int index_var = 0;
/*	register unsigned long int a = 0, b = 10000000,c;*/
	int i,j;
	unsigned long int cont;
								

	slavearray = malloc( M * sizeof(SLAVE) );
	memset(slavearray, 0, M*sizeof(SLAVE) );
	rectanglearray = malloc( N * sizeof(RECTANGLE) );
	memset(rectanglearray, 0, sizeof(RECTANGLE) );
	widtharray = malloc( N * sizeof(int) );
	memset(widtharray, 0, sizeof(RECTANGLE) );
	

	memset(x, 0, sizeof(x) );
	memset(out, 0, sizeof(out) );

	slavearray[0].IPaddress.s_addr = inet_addr("10.0.0.1");
	slavearray[0].power = 2;

	slavearray[1].IPaddress.s_addr = inet_addr("10.0.0.2");
	slavearray[1].power = 1;

    slavearray[2].IPaddress.s_addr = inet_addr("10.0.0.5");
	slavearray[2].power = 3;

    slavearray[3].IPaddress.s_addr = inet_addr("10.0.0.8");
	slavearray[3].power = 4;

    slavearray[4].IPaddress.s_addr = inet_addr("10.0.0.18");
	slavearray[4].power = 3;

    /*slavearray[5].IPaddress.s_addr = inet_addr("10.0.0.28");
	slavearray[5].power = 3;
*/

	/*slavearray[3].IPaddress.s_addr = inet_addr("10.0.0.9");
	slavearray[3].power = 2;*/

	rectanglearray[0].x1 =0;  rectanglearray[0].y1 = 0;
	rectanglearray[0].x2 = 639;   rectanglearray[0].y2 = 479;
	widtharray[0] = rectanglearray[0].x2 - rectanglearray[0].x1 + 1;

	rectanglearray[1].x1 =0;  rectanglearray[1].y1 = 0;
	rectanglearray[1].x2 = 799;   rectanglearray[1].y2 = 599;
	widtharray[1] = rectanglearray[1].x2 - rectanglearray[1].x1 + 1;
/*
    rectanglearray[2].x1 =0;  rectanglearray[2].y1 = 0;
	rectanglearray[2].x2 = 1023;   rectanglearray[2].y2 = 767;
	widtharray[2] = rectanglearray[2].x2 - rectanglearray[2].x1 + 1;

	rectanglearray[3].x1 =0;  rectanglearray[3].y1 = 0;
	rectanglearray[3].x2 = 799;   rectanglearray[3].y2 = 599;
	widtharray[3] = rectanglearray[3].x2 - rectanglearray[3].x1 + 1;
*/
	cont = cycle_matrix4(x, M-1,   N, M, widtharray, out, slavearray, rectanglearray);

	printf("\nNumero attivazioni: %u\n\n",cont);
	
	for (i=0;i<N;i++)
	{
		printf("Rettangolo %d (larghezza %d):\n",i,widtharray[i]);
		for (j=0; j<M; j++)
		{
			if (out[i][j]) printf(" - %d linee eseguite da %s(%.1f)\n", out[i][j], inet_ntoa(slavearray[j].IPaddress), slavearray[j].power );
		}
		printf("\n---------------------\n");
	}


	return 0;
}