#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>
#include <process.h>
#include <string.h>
#include <windows.h>

#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>

#include "definitions.h"
#include "myfunctions.h"
#include "resource.h"


#define Wait(s) WaitForSingleObject(s, INFINITE)
#define Signal(s) ReleaseMutex(s)

#define MAINBUFSIZE 1024
#define PICBUFSIZE 65536


void *SlaveTable(int Command, SLAVE *sl);
DWORD WINAPI Scheduler(LPVOID lp);
DWORD WINAPI receiving_thread(SOCKET *s2);




int x[MATRIX_WIDTH][MATRIX_WIDTH], out[MATRIX_WIDTH][MATRIX_WIDTH];
// sono le matrici utilizzate dalla funzione di allocazione, x  utilizzata per ciclare su tutte le
// possibili combinazioni ammesse, e out porta il risultato all'uscita


HINSTANCE hInstance, hInst;


HANDLE Receiver = 0, Sched = 0;
HANDLE GlobalArrayMutex, BitmapMutex, JobTerminated_Event, JobFailed_Event, NewSlaveHasArrived_Event,
       NewRequest_Event, HandledNewRequestEvent, ConsoleMutex;


HWND hMainWindow, hNewRequestWindow;
	
FILEDES FileArray[MAX_FILES], TempFileArray[16];
int fullFileArr[MAX_FILES], fullTempFileArr[16];

REQUEST RequestArray[MAX_REQUEST];
int fullReqArr[MAX_REQUEST];

REQUEST DoneRequestArray[MAX_REQUEST];
int fullDoneReqArr[MAX_REQUEST];

REQUEST NewRequest;
	
JOB JobArray[MAX_JOBS];
int fullJobArr[MAX_JOBS];

char name[20];

static OPENFILENAME ofn;

int Scheduler_TimeOut = 0;



DWORD WINAPI WindowThread(int *request_id)
{
	HWND hwnd;
	char buffer[32];
	int i = 0;
	MSG msg;
	RECT r;

	Wait(GlobalArrayMutex);

	i = 0;
	while (!( fullReqArr[i] && ( RequestArray[i].request_id == *request_id) )) i++;
	// Ora in i c' il puntatore alla richiesta corrente

	_snprintf(buffer,32, "Request %d (%dx%d)", *request_id, RequestArray[i].size_x, RequestArray[i].size_y);


	//AdjustRect

	r.left = 0;
	r.top = 0;
	r.right = RequestArray[i].size_x;
	r.bottom = RequestArray[i].size_y;

	AdjustWindowRect(&r, WS_BORDER | WS_CAPTION | WS_SYSMENU, FALSE);
	
	RequestArray[i].hWindow = CreateWindow( "request_window", buffer,
											  WS_BORDER | WS_CAPTION | WS_SYSMENU,
											  CW_USEDEFAULT, CW_USEDEFAULT,
											  r.right-r.left, r.bottom-r.top,
											  NULL, NULL, hInstance, NULL ) ;
	hwnd = RequestArray[i].hWindow;
	
	Signal(GlobalArrayMutex);

	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);

	while ( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	ExitThread(0);
	return 0;

}



LRESULT CALLBACK Request_Window_Procedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	int oldMode ;
	int i;
	char *bitmap_surface;
	BITMAPINFO bitmap_info;
	int size_x, size_y;

  

	switch (message)
	{
	case WM_CREATE :
		return 0;

	case WM_SIZE :
		return 0;

	case WM_PAINT :
        /*if ((hdc = GetDC (New_render_window)) == NULL)
			return 0;*/
		Wait(GlobalArrayMutex);
		
		i = 0;
		while  ( !(fullReqArr[i] && (RequestArray[i].hWindow == hwnd) )  && (i < MAX_REQUEST)       ) i++;
		if (i==MAX_REQUEST)
		{
			i = 0;
			while (!(fullDoneReqArr[i] && (DoneRequestArray[i].hWindow == hwnd) ) && (i<MAX_REQUEST) ) i++;
			if (i==MAX_REQUEST) break;
			// Ora in i c' l'indice alla richiesta nel vettore DoneRequestArray

			bitmap_surface = DoneRequestArray[i].bitmap_surface;
			size_x = DoneRequestArray[i].size_x;
			size_y = DoneRequestArray[i].size_y;
			memset(&bitmap_info, 0, sizeof(BITMAPINFO) );
			//memcpy(&bitmap_info.bmiHeader, &DoneRequestArray[i].bitmap_info, sizeof(BITMAPINFOHEADER) );
			CopyMemory(&bitmap_info.bmiHeader, &DoneRequestArray[i].bitmap_info, sizeof(BITMAPINFOHEADER));
		}
		else
		{
			// ora in i c' l'indice alla richiesta nel vettore RequestArray
			bitmap_surface = RequestArray[i].bitmap_surface;
			size_x = RequestArray[i].size_x;
			size_y = RequestArray[i].size_y;
			memset(&bitmap_info, 0, sizeof(BITMAPINFO) );
			//memcpy(&bitmap_info.bmiHeader, &RequestArray[i].bitmap_info, sizeof(BITMAPINFOHEADER) );
			CopyMemory(&bitmap_info.bmiHeader, &RequestArray[i].bitmap_info, sizeof(BITMAPINFOHEADER));
		}

		Signal(GlobalArrayMutex);

		hdc = BeginPaint(hwnd,&ps);
        oldMode = SetStretchBltMode (hdc, STRETCH_DELETESCANS) ;
        
		if (bitmap_surface)
		{
			/*StretchDIBits (hdc, 0, 0,	size_x, size_y,	
						    0, 0,   size_x, size_y,
						    bitmap_surface, (LPBITMAPINFO) &RequestArray[i].bitmap_info, DIB_RGB_COLORS, SRCCOPY );*/
			/*StretchDIBits (hdc, -renderwin_xoffset, -renderwin_yoffset, render_width,	render_height, 0, 0, render_bitmap.header.biWidth,
						 render_bitmap.header.biHeight, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap,  DIB_RGB_COLORS, SRCCOPY );*/
			 
			//Wait(BitmapMutex);
			StretchDIBits (hdc, 0, 0, size_x,	size_y, 0, bitmap_info.bmiHeader.biHeight, bitmap_info.bmiHeader.biWidth,
					 -bitmap_info.bmiHeader.biHeight, bitmap_surface, (LPBITMAPINFO) &bitmap_info,  DIB_RGB_COLORS, SRCCOPY );
			
			/*if (bitmap_info.bmiHeader.biHeight>0) bitmap_info.bmiHeader.biHeight = -bitmap_info.bmiHeader.biHeight;
			res = SetDIBitsToDevice(hdc, 0, 0, size_x-10, size_y, 
								   0, 0, 0, size_y,
								   bitmap_surface, (LPBITMAPINFO) &bitmap_info, DIB_RGB_COLORS);*/
			//Signal(BitmapMutex);
		}
		
		
	
		
		/*StretchDIBits (hdc, 0, 0, render_width, lasty, 0, render_bitmap.header.biHeight - 1 ,
						 render_bitmap.header.biWidth, -lasty, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap, DIB_RGB_COLORS, SRCCOPY );*/
	
        
        
        SetStretchBltMode (hdc, oldMode) ;
        EndPaint (hwnd, &ps) ;

		return 0;

	case WM_DESTROY :
		i = 0;
		while  (!(fullDoneReqArr[i] && (DoneRequestArray[i].hWindow == hwnd))   && (i<MAX_REQUEST)) i++;
		
		if (i<MAX_REQUEST)
		{
			free(DoneRequestArray[i].bitmap_surface);
			fullDoneReqArr[i] = 0;
		}
		
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
	
}





int GetNewFileId(void)
{
	static int cont = 0;
	static HANDLE Mutex = 0;
	int id = 0;

	if (cont == 0) 	Mutex = CreateMutex(NULL, TRUE, NULL);
	else WaitForSingleObject(Mutex, INFINITE);

	cont++;
	id = cont;

	ReleaseMutex(Mutex);
	return id;
}


void AddFileToArray(FILEDES f)
{
	int i=0, already_present = 0;

	while ( (i<MAX_FILES) && (!already_present) )
	{
		if (fullFileArr[i])
		{ 
			if ((FileArray[i].request_id == f.request_id) && (!strcmp(FileArray[i].name, f.name) ) ) already_present = 1;
		}
		i++;
	}
	i--;
		
	if (!already_present)
	{
		i=0;
		while ( (fullFileArr[i]) && (i<MAX_JOBS) ) i++;
	}

	if (i< MAX_JOBS)
	{
		memcpy(&FileArray[i], &f, sizeof(FILEDES) );
		fullFileArr[i] = 1;
	}
	return;
}



void InitOpenFileStructure(void)
{
	static char szFilter[] = "Files PoV (*.pov)\0*.pov\0" \
						   "Tutti i files (*.*)\0*.*\0\0";
	static char FileName[256];
	static char CompleteFileName[256];


	memset(&ofn, 0, sizeof(OPENFILENAME) );
	memset(FileName, 0, 256);
	memset(CompleteFileName, 0, 256);
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.hInstance = NULL;
	ofn.lpstrFilter = szFilter;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.nMaxFile = _MAX_PATH;
	ofn.lpstrFileTitle = FileName;
	ofn.lpstrFile = CompleteFileName;
	ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = NULL;
	ofn.Flags = 0;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = "pov";
	ofn.lCustData = 0L;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	return;
}







BOOL ValidFloat(char *s)
{
	int conta_punti=0;

	if (((*s)!='0') && ((*s)!='1')) return FALSE;
	s++;
	while (*s)
	{
		if ((*s)=='.') conta_punti++;
		else if (((*s)<'0') || ((*s)>'9')) return FALSE;
		s++;
	}
	if (conta_punti<=1) return TRUE;
	else return FALSE;
}


BOOL CALLBACK NewRequestWindowProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    /*BOOL fError; */
	int Larghezza = 0, Altezza = 0, AAon = 0;
	BOOL Ok_Larghezza = FALSE, Ok_Altezza = FALSE, Ok_AA = TRUE, Ok_Files = 0, i=0;
	char AA_buffer[5], ext[4];

 
    switch (message) 
    { 
        case WM_INITDIALOG: 
            {
				hNewRequestWindow = hwndDlg;
				return TRUE; 
			}
 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            {
				case IDC_AACHECK :
					{
						if (IsDlgButtonChecked(hwndDlg, IDC_AACHECK) == BST_CHECKED) EnableWindow( GetDlgItem(hwndDlg, IDC_ANTIALIASING), TRUE );
						else EnableWindow( GetDlgItem(hwndDlg, IDC_ANTIALIASING), FALSE );
						return TRUE;
					}
				
				case IDCANCEL: 
                  EndDialog(hwndDlg, 0);
				  return TRUE;

				case IDOK :
				{
					memset(AA_buffer, 0, 5);
					Ok_AA = TRUE;
					AAon = 0;
					Larghezza = GetDlgItemInt( hwndDlg, IDC_LARGHEZZA, &Ok_Larghezza, FALSE);
					Altezza = GetDlgItemInt( hwndDlg, IDC_ALTEZZA, &Ok_Altezza, FALSE);
					if (IsDlgButtonChecked(hwndDlg, IDC_AACHECK) == BST_CHECKED)
					{
						GetDlgItemText( hwndDlg, IDC_ANTIALIASING, AA_buffer, 4);
						Ok_AA = ValidFloat(AA_buffer);
						AAon = 1;
					}

					Ok_Files = 1;
					if (Ok_Larghezza && Ok_Altezza && Ok_AA && Ok_Files)
					{
						NewRequest.size_x = Larghezza;
						NewRequest.size_y = Altezza;
						memcpy( &NewRequest.AA, AA_buffer, 5);
						NewRequest.AAon = AAon;

						EnableWindow( GetDlgItem(hMainWindow,IDNEWREQUEST), FALSE );

						/* Segnala EVENTO !!!!!!!!!!!!!*/
						SetEvent(NewRequest_Event);
						WaitForSingleObject(HandledNewRequestEvent, INFINITE);
						EnableWindow( GetDlgItem(hMainWindow,IDNEWREQUEST), TRUE );
						
					
						ResetEvent(HandledNewRequestEvent);
						ResetEvent(NewRequest_Event);
						EndDialog(hwndDlg, 0);
				  						
					}
					else MessageBox(hwndDlg, "Errore nella compilazione dei parametri! Ricontrollare!", "Add New Request", MB_OK);
					
					return TRUE;
				}

				case IDADDFILE :
					{
						InitOpenFileStructure();
						if (GetOpenFileName(&ofn))
						{
							printf("Selected file: %s (%s)\n", ofn.lpstrFile, ofn.lpstrFileTitle);
							
							SendDlgItemMessage(hwndDlg, IDC_FILELIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) ofn.lpstrFileTitle);

							i = 0;
							while (fullTempFileArr[i]) i++;
							
							fullTempFileArr[i] = 1;
							strcpy(TempFileArray[i].name, ofn.lpstrFile);
							TempFileArray[i].size = 0;
							
							strcpy(ext, &TempFileArray[i].name[ strlen(TempFileArray[i].name)-4 ]);
							CharUpperBuff(ext,4);
							ofn.lpstrFile[ strlen(ofn.lpstrFileTitle) ] = 0;
							if (strcmp(ext,".POV")==0)  SetWindowText( GetDlgItem(hwndDlg, IDC_WORKDIRTXT), ofn.lpstrFile );
							
						}
						return TRUE;
					}



                    
				default :
					return TRUE; 
            } 
    } 
    return FALSE; 
} 
 



	


BOOL CALLBACK MainWindowProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    int SchedId;
	static sl_count = 0;
	static SOCKET sock_broad;
	static SOCKET s;
	static struct sockaddr_in ra,la;
	static PACKET p;

	static struct hostent *localhost;
		
	WORD wVersionRequested = MAKEWORD(1,1);
    WSADATA wsaData; 
    int err; 
	BOOL fBrCast;

	int RecId;


 
    switch (message) 
    { 
        case WM_INITDIALOG: 
            {
				memset(fullJobArr, 0, MAX_REQUEST * sizeof(int) );
				memset(JobArray, 0, MAX_JOBS * sizeof(JOB) );
	
				memset(fullFileArr, 0, MAX_FILES * sizeof(int) );
				memset(FileArray, 0, MAX_FILES * sizeof(FILEDES) );

				memset(fullTempFileArr, 0, 16 * sizeof(int) );
				memset(TempFileArray, 0, 16 * sizeof(FILEDES) );

		
	
				memset(fullReqArr, 0, MAX_REQUEST * sizeof(int) );
				memset(RequestArray, 0, MAX_REQUEST * sizeof(REQUEST) );

				memset(fullDoneReqArr, 0, MAX_REQUEST * sizeof(int) );
				memset(DoneRequestArray, 0, MAX_REQUEST * sizeof(REQUEST) );
		
				SlaveTable(ST_INIT, NULL);

				
				JobTerminated_Event = CreateEvent(NULL, FALSE, FALSE, NULL);
				JobFailed_Event = CreateEvent(NULL, FALSE, FALSE, NULL);
				NewSlaveHasArrived_Event = 	CreateEvent(NULL, FALSE, FALSE, NULL);
				NewRequest_Event = CreateEvent(NULL, TRUE, FALSE, NULL);
				HandledNewRequestEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

				ConsoleMutex = CreateMutex(NULL, FALSE, NULL);
				GlobalArrayMutex = CreateMutex(NULL, FALSE, NULL);
				BitmapMutex = CreateMutex(NULL,FALSE, NULL);
				//LastPacketsMutex = CreateMutex(NULL, FALSE, NULL);

				


				
				Sched = CreateThread(NULL, 0, Scheduler, NULL, 0, &SchedId);
				
				/*CheckDlgButton(hwndDlg, ID_ABSREL, fRelative); */
				hMainWindow = hwndDlg;


				if ( (err = WSAStartup(wVersionRequested, &wsaData) ) != 0 )
				{		
					perror("Can't load any Winsock DLL\n");
					return 1;
				}

				sock_broad = socket(AF_INET, SOCK_DGRAM, 0);
	    
				fBrCast = TRUE;
				err = setsockopt(sock_broad, SOL_SOCKET, SO_BROADCAST, (char *) &fBrCast, sizeof(BOOL) );

				memset( (char *) &ra, 0, sizeof(struct sockaddr_in));
				ra.sin_family = AF_INET;
				ra.sin_addr.s_addr = INADDR_BROADCAST;
				ra.sin_port = SLAVE_UDP_PORT;
				
				memset( &p, 0, PACKETSIZE);
				p.command = CALLFORSLAVES_COMMAND;
				p.datagram_id = 0;


				gethostname(name,20);
				localhost = gethostbyname(name);
	
				
				/*memset( (char *) &ra, 0, sizeof(struct sockaddr_in));
				ra.sin_family = AF_INET;
				ra.sin_addr.s_addr = ip.s_addr; *//* ( (struct in_addr *)(host->h_addr))->s_addr;*/
				/*ra.sin_port = 12345;*/

				memset( (char *) &la, 0, sizeof(struct sockaddr_in));
				la.sin_family = AF_INET;
				la.sin_addr.s_addr = ( (struct in_addr *)(localhost->h_addr))->s_addr; 
				la.sin_port = COORD_UDP_PORT;

		
				s = socket(AF_INET, SOCK_DGRAM, 0);
    
				bind( s, (struct sockaddr *) &la, sizeof(struct sockaddr_in));
 
				Receiver = CreateThread( NULL, 0, receiving_thread, &s, 0, &RecId);

				return TRUE; 
			}
 
        case WM_SYSCOMMAND:
			if (wParam == SC_CLOSE)
			{
				if ( MessageBox( hwndDlg, 
				     "You should use the Exit button to close gracefully this application.\nAre you sure you want to close it this way?", 
					 "Quit Application", MB_YESNO | MB_ICONWARNING ) == IDYES ) ExitProcess(1);
            }
			break;
		
		
		case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDNEWREQUEST :
					{
						printf("New Request Dialog open...\n");
						DialogBox(hInst, MAKEINTRESOURCE(IDD_NEWREQUEST), hMainWindow, (DLGPROC) NewRequestWindowProc);
						/*ShowWindow(hNewRequestWindow, SW_SHOW); */
						printf("New Request Dialog closed.\n");

						return TRUE;
					}

				case IDBROADCAST :
					{
						memset( &p, 0, PACKETSIZE);
						p.command = CALLFORSLAVES_COMMAND;
						p.datagram_id = 0;

						sendto(sock_broad, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
							
						break;
					}

			
				case IDEXIT: 
    				SlaveTable(ST_CLOSESLAVES, NULL);
					/*DestroyWindow(hwndDlg); 
                    hMainWindow = NULL; */
					EndDialog(hwndDlg, 12);
					return TRUE;

				case IDEXITKILL: 
                    
					SlaveTable(ST_KILLSLAVES, NULL);
					/*DestroyWindow(hwndDlg); 
                    hMainWindow = NULL; */
					EndDialog(hwndDlg, 12);
      				return TRUE;
			
                    
				default :
					return TRUE; 
            }
					
    } 
    return FALSE; 
} 
 

int GetNewJobId(void)
{
	static int cont = 0;
	static HANDLE Mutex = 0;
	int id = 0;

	if (cont == 0) 	Mutex = CreateMutex(NULL, TRUE, NULL);
	else WaitForSingleObject(Mutex, INFINITE);

	cont++;
	id = cont;

	ReleaseMutex(Mutex);
	return id;
}

int GetNewDatagramId(void)
{
	static int cont = 0;
	static HANDLE Mutex = 0;
	int id = 0;

	if (cont == 0) 	Mutex = CreateMutex(NULL, TRUE, NULL);
	else WaitForSingleObject(Mutex, INFINITE);

	cont++;
	id = cont;

	ReleaseMutex(Mutex);
	return id;
}


int GetNewRequestId(void)
{
	static int cont = 0;
	static HANDLE Mutex = 0;
	int id = 0;

	if (cont == 0) 	Mutex = CreateMutex(NULL, TRUE, NULL);
	else WaitForSingleObject(Mutex, INFINITE);

	cont++;
	id = cont;

	ReleaseMutex(Mutex);
	return id;
}


void AddJobToArray(JOB j)
{
	int i=0, already_present = 0;

	while ( (i<MAX_JOBS) && (!already_present) )
	{
		if (fullJobArr[i])
		{
			if (JobArray[i].job_id == j.job_id) already_present = 1;
		}
		i++;
	}
	i--;
		
	if (!already_present)
	{
		i=0;
		while ( (fullJobArr[i]) && (i<MAX_JOBS) ) i++;
	}

	if (i< MAX_JOBS)
	{
		memcpy(&JobArray[i], &j, sizeof(JOB) );
		fullJobArr[i] = 1;
	}
	return;
}






void *SlaveTable(int Command, SLAVE *sl)
{
	static SLAVE *slavearray = NULL;
	static int *status = NULL, pointer = 0;
	static HANDLE hMutex = 0;
	int N = 64, i, already_present = 0, cont = 0, j = 0;
	SOCKET s;
	PACKET p;
	struct sockaddr_in ra;

	SLAVE *array = NULL;

	if (hMutex) WaitForSingleObject(hMutex, INFINITE);

	switch( Command )
	{
	   case ST_INIT:
		   {
			   hMutex = CreateMutex(NULL, TRUE, NULL);
			   slavearray = (SLAVE *) malloc( N * sizeof(SLAVE) );
			   status = (int *) malloc( N* sizeof(int) );
			   memset( (void *) slavearray, 0, N * sizeof(SLAVE) );
			   memset( (void *) status, 0, N * sizeof(int) );
			   break;
		   }
	   case ST_ADD:
		   {
			   if ( (slavearray != NULL) && (status != NULL) )
			   {
				   i = 0;
				   already_present = 0; 
				   while ( (i<N) && !already_present )
				   {
					   if (status[i] && (slavearray[i].IPaddress.s_addr == (*sl).IPaddress.s_addr)) already_present = 1;
					   i++;
				   }
				   
				   i--;
				   if (!already_present)   /* Se c' gi aggiorno i campi, altrimenti cerco una posizione libera */
				   {
					   i = 0;
				       while ( status[i] ) i++;  /* Cerca la prima posizione libera nell'array */
					 
					   // Visto che non c'era il nuovo slave allora lo aggiungo
/*					   SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) inet_ntoa(sl->IPaddress))*/

				   }
				   memcpy( &slavearray[i], sl, sizeof(SLAVE) );
			       status[i] = 1;
			   }
			   break;
		   }
	   case ST_DELETE :
		   {
			   if ( (slavearray != NULL) && (status != NULL) )
			   {
				   i = 0;
				   while ( (i<N) && ( slavearray[i].IPaddress.s_addr != (*sl).IPaddress.s_addr ) ) i++;
				   if (i<N) status[i] = 0;
			   }
			   break;
		   }
	   case ST_UNLOAD :
		   {
			   free( (void *) slavearray);
			   free( (void *) status);
			   ReleaseMutex(hMutex);
			   CloseHandle(hMutex);
			   return NULL;
			   break;
		   }
	   case ST_PRINT :
		   {
			   if ( (slavearray != NULL) && (status != NULL) )
			   {
				   for (i=0; i<N; i++)
					   if (status[i]) printf("Host %s at position %d with actual power = %d.\n", inet_ntoa(slavearray[i].IPaddress),i, slavearray[i].power);
			   }
			   else printf("Slave Table not initialized.\n");
			   break;
		   }
	   case ST_RESET:
		   {
			   pointer = 0;
			   break;
		   }
	   case ST_CLEARALL :
		   {
			   i = 0;
			   while (i<N) status[i] = 0;
			   break;
		   }
	   case ST_GETNEXT:
		   {
			   while ((status[pointer]==0) && (pointer<N)) pointer++;
			
			   if (pointer < N) memcpy( sl, &slavearray[pointer], sizeof(SLAVE) );
			   else memset( sl, 0, sizeof(SLAVE) );
			   break;
		   }
	   case ST_LOOKUPNODE :
		   {
			   i = 0;
			   already_present = 0; 
			   while ( (i<N) && !already_present )
			   {
				   if (status[i] && (slavearray[i].IPaddress.s_addr == (*sl).IPaddress.s_addr)) already_present = 1;
				   i++;
			   }
			   i--;

			   if (already_present) memcpy(sl, &slavearray[i], sizeof(SLAVE) );
			   else memset( sl, 0, sizeof(SLAVE) );
			   break;
		   }
	   case ST_GETARRAY :
		   {
			   i = 0; cont = 0;
			   while (i<N)
			   {
				   if (status[i]) cont++;
				   i++;
			   }

			   array = malloc( (cont+1)*sizeof(SLAVE) );
			   memset(array, 0, (cont+1)*sizeof(SLAVE));


			   if (cont>0)
			   {
				   i = 0; j = 0;
				   while (i<N)
				   {
					   if (status[i])
					   {
						   memcpy( &array[j], &status[i], sizeof(SLAVE) );
						   j++;
					   }
					   i++;
				   }
			   }
			   break;
		   }
	   case ST_GETFREEARRAY :
	   /*case ST_GETFAILEDARRAY :*/
		   {
			   i = 0; cont = 0;
			   while (i<N)
			   {
				   if ((status[i]) && (slavearray[i].status == FREE_SLAVE)) cont++;
				   i++;
			   }

			   array = malloc( (cont+1)*sizeof(SLAVE) );
			   memset(array, 0, (cont+1)*sizeof(SLAVE));


			   if (cont>0)
			   {
				   i = 0; j = 0;
				   while (i<N)
				   {
					   if ( (status[i]) && (slavearray[i].status == FREE_SLAVE) )
					   {
						   memcpy( &array[j], &slavearray[i], sizeof(SLAVE) );
						   j++;
					   }
					   i++;
				   }
			   }
			   break;
		   }

	   case ST_CLOSESLAVES:
		   {
			   s = socket(AF_INET, SOCK_DGRAM, 0);

			   memset( (char *) &ra, 0, sizeof(struct sockaddr_in));
			   ra.sin_family = AF_INET;
			   ra.sin_port = SLAVE_UDP_PORT;
				
			   memset( &p, 0, PACKETSIZE);
			   p.command = SLAVEQUIT_COMMAND;
			   p.datagram_id = 0;

			   i = 0;

			   while (i<N)
			   {
				   if (status[i])
				   {
					   status[i] = 0;
					   ra.sin_addr.s_addr = slavearray[i].IPaddress.s_addr;
					   printf("Sending %s quit message.\n", inet_ntoa(ra.sin_addr) );
					   sendto(s, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
				   }
				   i++;
			   }
			   closesocket(s);
			   break;
		   }

		case ST_KILLSLAVES:
		   {
			   s = socket(AF_INET, SOCK_DGRAM, 0);

			   memset( (char *) &ra, 0, sizeof(struct sockaddr_in));
			   ra.sin_family = AF_INET;
			   ra.sin_port = SLAVE_UDP_PORT;
				
			   memset( &p, 0, PACKETSIZE);
			   p.command = SLAVEKILL_COMMAND;
			   p.datagram_id = 0;

			   i = 0;

			   while (i<N)
			   {
				   if (status[i])
				   {
					   status[i] = 0;
					   ra.sin_addr.s_addr = slavearray[i].IPaddress.s_addr;
					   printf("Sending %s quit message.\n", inet_ntoa(ra.sin_addr) );
					   sendto(s, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
				   }
				   i++;
			   }
			   closesocket(s);
			   break;
		   }
	
	}
	ReleaseMutex(hMutex);
	return array;
}


int IndexInRequestArray(unsigned int request_id)
{
	int i,found;
	
	i = 0; found = 0;
	while ((i < MAX_REQUEST) && (!found))
	{
		if (  (fullReqArr[i]) && (RequestArray[i].request_id == request_id)   )  found = 1;
		else i++;
	}
	return i;
}


					   
	
int IndexInJobArray(unsigned int job_id)
{
	int i,found;
	
	i = 0; found = 0;
	while ((i < MAX_JOBS) && (!found))
	{
		if (  (fullJobArr[i]) && (JobArray[i].job_id == job_id)   )  found = 1;
		else i++;
	}
	return i;
}



int IndexInJobArrayFromAddress(struct in_addr ip)
{
	int i,found;
	
	i = 0; found = 0;
	while ((i < MAX_JOBS) && (!found))
	{
		if (  (fullJobArr[i])
				&& (JobArray[i].sl.IPaddress.s_addr == ip.s_addr)
				&& (JobArray[i].status == JOB_WORKING)  )  found = 1;
		else i++;
	}
	return (found ? i : -1);
}
		

int IndexInBox(int listbox_id, int id)
{
	char txtbuffer[32];
	struct in_addr ip;
	int index;

	switch(listbox_id)
	{
	case IDC_REQUESTLIST:
		_snprintf(txtbuffer,32, "Request %d", id);
		break;
	case IDC_JOBLIST:
		_snprintf(txtbuffer,32, "Job %d", id);
		break;
	case IDC_SLAVELIST:
		ip.S_un.S_addr = id;
		_snprintf(txtbuffer,32, "%s", inet_ntoa(ip));
		break;
	}
	index = SendDlgItemMessage(hMainWindow, listbox_id, LB_FINDSTRING, -1, (LPARAM) (LPCTSTR) txtbuffer);
	return index;
}


void Fail(JOB *Job, int i, SOCKET s, SOCKET tcp_sock, char *txtbuffer)
{
	printf("Slave %s has failed!\n",inet_ntoa(Job->sl.IPaddress));
	WaitForSingleObject(GlobalArrayMutex,INFINITE);
	JobArray[i].status = JOB_FAILED;
	JobArray[i].IndexInBox = IndexInBox( IDC_JOBLIST, JobArray[i].job_id);
	SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_DELETESTRING, (WPARAM) JobArray[i].IndexInBox, 0);
	memset(txtbuffer, 0, 64);
	_snprintf(txtbuffer, 64-1, "Job %u (%u,%u)->(%u,%u) of Request %u [FAILED]", 
					Job->job_id, Job->rect.x1, Job->rect.y1, Job->rect.x2, Job->rect.y2,Job->request_id );
	JobArray[i].IndexInBox = SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
	
	SlaveTable(ST_DELETE, &(Job->sl));
	JobArray[i].sl.IndexInBox = IndexInBox( IDC_SLAVELIST, JobArray[i].sl.IPaddress.S_un.S_addr );
	SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_DELETESTRING, (WPARAM) JobArray[i].sl.IndexInBox, 0);
		
	if (s) closesocket(s);
	if (tcp_sock) closesocket(tcp_sock);
		
	SetEvent(JobFailed_Event);
	
	ReleaseMutex(GlobalArrayMutex);
	ExitThread(-1);
}


	


char *GetFileName(char *fullname)
{
	char *c;

	c = fullname + strlen(fullname);

	while (*c != '\\')
	{
		if (c==fullname) break;
		c--;
	}
	c++;
	return c;
}

DWORD WINAPI DoJob(JOB *Job)
{	
	REQUEST r;
	int i,j, found = 0, newline = 0, Result, a, b,
		tx_count, fd, nread = 0, POVindex = -1,
		MainBufPtr = 0, currenty = 0, nread_tot = 0, interrotto = 0;
	unsigned int nwrite = 0, ntot = 0, W, H, linesize = 0, render_bitmap_bpl = 0;
	LARGE_INTEGER freq, count1, count2, diff;
	char txtbuffer[64], count, *MainBuffer, *POVname, commandline[64];
	SOCKET s = 0, tcp_sock = 0;
	struct sockaddr_in ra, ra_tcp;
	PACKET p;
	float secsperline = 0;


	memset(commandline, 0, 64);
	
	WaitForSingleObject(GlobalArrayMutex,INFINITE);

	i = 0; j = 0; found = 0;
	while ((i < MAX_JOBS) && (!found))
	{
		if (  (fullJobArr[i]) && (JobArray[i].job_id == (Job->job_id))   )  found = 1;
		else i++;
	}
	Job->ServingThread = JobArray[i].ServingThread;


	memset(txtbuffer, 0, sizeof(txtbuffer));
	_snprintf(txtbuffer, sizeof(txtbuffer)-1,"Job %u", Job->job_id );
	Result = SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_FINDSTRING, -1, (LPARAM) (LPCTSTR) txtbuffer);
	if (Result != LB_ERR)
		SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_DELETESTRING, (WPARAM) Result, 0);

	memset(txtbuffer, 0, sizeof(txtbuffer));
	_snprintf(txtbuffer, sizeof(txtbuffer)-1, "Job %u (%u,%u)->(%u,%u) of Request %u [WORKING]", 
				Job->job_id, Job->rect.x1, Job->rect.y1, Job->rect.x2, Job->rect.y2,Job->request_id );
	Job->IndexInBox = SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
	AddJobToArray(*Job);

	memset(txtbuffer, 0, sizeof(txtbuffer));
	_snprintf(txtbuffer, sizeof(txtbuffer)-1,"%s", inet_ntoa(Job->sl.IPaddress) );
	Result = SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_FINDSTRING, -1, (LPARAM) (LPCTSTR) txtbuffer);
	if (Result != LB_ERR)
		SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_DELETESTRING, (WPARAM) Result, 0);

	memset(txtbuffer, 0, sizeof(txtbuffer));
	_snprintf(txtbuffer, sizeof(txtbuffer)-1, "%s power = %u [WORKING]", inet_ntoa(Job->sl.IPaddress), Job->sl.power );
	Job->sl.IndexInBox = SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);

	SlaveTable(ST_ADD, &(Job->sl) );
	


	
	
	i = 0; j = 0; found = 0;
	while ((i < MAX_JOBS) && (!found))
	{
		if (  (fullJobArr[i]) && (JobArray[i].job_id == (Job->job_id))   )  found = 1;
		else i++;
	}
	JobArray[i].secsleft = (JobArray[i].rect.x2 - JobArray[i].rect.x1) * (JobArray[i].rect.y2 - JobArray[i].rect.y1) / JobArray[i].sl.power;
	Job->secsleft = JobArray[i].secsleft;


	found = 0;
	while ((j < MAX_REQUEST) && (!found))
	{
		if (  (fullReqArr[j]) && (RequestArray[j].request_id == Job->request_id)   )  found = 1;
		else j++;
	}
	memcpy(&r, &RequestArray[j], sizeof(REQUEST) );

	ReleaseMutex(GlobalArrayMutex);

	
	WaitForSingleObject(ConsoleMutex, INFINITE);
	printf("----------------------------------\n");
	
	printf("Job Id = %u\n",Job->job_id);
	printf("Request Id = %u\n",Job->request_id);
	printf("Rectangle (%d,%d) -> (%d,%d)\n",Job->rect.x1,Job->rect.y1,Job->rect.x2,Job->rect.y2);
	printf("Slave: %s\n",inet_ntoa(Job->sl.IPaddress));
	printf("----------------------------------\n\n");
	ReleaseMutex(ConsoleMutex);

//	Job->NewPacketEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		
	s = socket(AF_INET, SOCK_DGRAM, 0);
	memset(&ra,0, sizeof(struct sockaddr_in));
	ra.sin_addr.s_addr = Job->sl.IPaddress.s_addr;
	ra.sin_port = SLAVE_UDP_PORT;
	ra.sin_family = AF_INET;
	
	/* Devo anche aprire una connessione TCP con lo slave come servitore */

	
	
	memset( &p, 0, PACKETSIZE );
	p.command = GETFILES_COMMAND;
	p.datagram_id = GetNewDatagramId();
	memcpy( p.data, &(Job->request_id), sizeof(int) );
	
	a = 0; b = 5; count = 0;
	while (a < MAX_FILES )
	{
		if (   (fullFileArr[a]) && (FileArray[a].request_id == Job->request_id)   )
		{
			if ( !strcmp( CharUpper(&FileArray[a].name[ strlen(FileArray[a].name) - 4]), ".POV" ) ) POVindex = a;

			memcpy( &(p.data[b]), (char *) &(FileArray[a].size), sizeof(int));
			b += sizeof(int);
			strcpy( &(p.data[b]), FileArray[a].name /*, 1 + strlen(FileArray[a].name)*/ );
			b += strlen(FileArray[a].name) + 1;
			count++;
		}
		a++;
	}
	p.data[4] = count;

		

	WaitForSingleObject(GlobalArrayMutex,INFINITE);
	tx_count = 0;
	printf("Sending GETFILES command...\n");
	sendto(s, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in));
	memcpy( &(Job->LastPacketSent), &p, PACKETSIZE);
	AddJobToArray( *Job );
	tx_count++;
	ReleaseMutex(GlobalArrayMutex);
	
	
	
	while ( (tx_count<3) && (WaitForSingleObject( Job->NewPacketEvent, 15000) == WAIT_TIMEOUT)  )
	{
		sendto(s, (char *) &(Job->LastPacketSent), PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in));
		tx_count++;
	}
	//printf("Error: %d\n",GetLastError());
	if (tx_count >= 3)
	{
		Fail( Job, i,s,0, txtbuffer);
	}
	ResetEvent(Job->NewPacketEvent);
	memcpy(&Job->LastPacketReceived, &JobArray[i].LastPacketReceived, PACKETSIZE);
	printf("Received answer to GETFILES...\n");

	// Se sono qui allora  arrivata la risposta al comando GETFILES	

	
	// Connetto la socket TCP
	tcp_sock = socket(AF_INET, SOCK_STREAM, 0);
	memcpy(&ra_tcp, &ra, sizeof(struct sockaddr_in));
	ra_tcp.sin_port = SLAVE_TCP_PORT;
	if (connect( tcp_sock, (struct sockaddr *) &ra_tcp, sizeof(struct sockaddr_in) ) == SOCKET_ERROR)
	{
		printf("Error %d: can't connect TCP socket to slave.\n",WSAGetLastError());
		Fail (Job, i, s, tcp_sock, txtbuffer);
	}
	
	
	
	Wait(GlobalArrayMutex);

	switch(JobArray[i].LastPacketReceived.command)
	{
		case ALREADYHAVE_COMMAND :
		{
			printf("Already have files...\n");
			//shutdown(tcp_sock, 1);
			break;
		}
		
		case DONTHAVE_COMMAND :
		{
			// Devo trasmettere i files necessari

			printf("Sending files...\n");
			MainBuffer = malloc( MAINBUFSIZE );

			a = 0;
			while (a < MAX_FILES )
			{
				if (   (fullFileArr[a]) && (FileArray[a].request_id == Job->request_id)   )
				{
					ntot = 0;
					fd = _open( FileArray[a].name, _O_RDONLY | _O_BINARY, _S_IREAD);
					while ( (nread = read(fd, MainBuffer, MAINBUFSIZE)) > 0 )
						if ( (nwrite = send(tcp_sock, MainBuffer, nread, 0)) != SOCKET_ERROR ) ntot += nwrite;
						else 
							{
								printf("Error %d transmitting file %s.\n", WSAGetLastError(), FileArray[a].name);
								Signal(GlobalArrayMutex);
								Fail(Job, i, s, tcp_sock, txtbuffer);
							}

					_close(fd);
					if (ntot != FileArray[a].size) printf("Warning: File size mismatch in file %s\n", FileArray[a].name);
				}
				a++;
			}
			//shutdown(tcp_sock,1);
			free(MainBuffer);

			break;
		}
	default :
		{
			Signal(GlobalArrayMutex);
			Fail(Job, i, s, tcp_sock, txtbuffer);
			break;
		}
	}

	//Signal(GlobalArrayMutex);
	//printf("Shutting down reading TCP connection\n");
	//shutdown(tcp_sock,1);
	
	a = IndexInRequestArray(Job->request_id);
	Signal(GlobalArrayMutex);

	W = RequestArray[ a ].size_x;
	H = RequestArray[ a ].size_y;

	sprintf(txtbuffer, " +AA%s", RequestArray[a].AA);


//	GetShortPathName(FileArray[POVindex].name, POVname, 32);
	POVname = GetFileName(FileArray[POVindex].name);
	

	

	_snprintf(commandline, 64, "+I%s +W%u +H%u +SC%u +EC%u +SR%u +ER%u%s", POVname, W, H,
								Job->rect.x1+1, Job->rect.x2+1, Job->rect.y1+1, Job->rect.y2 + 1,
								( RequestArray[a].AAon ? txtbuffer : "") );

	memset( &p, 0, PACKETSIZE );
	p.command = STARTRENDERING_COMMAND;
	p.datagram_id = GetNewDatagramId();
	strcpy(p.data, commandline);
	
	Wait(GlobalArrayMutex);
	tx_count = 0;
	sendto(s, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in));
	memcpy( &(Job->LastPacketSent), &p, PACKETSIZE);
	AddJobToArray( *Job );
	tx_count++;
	ReleaseMutex(GlobalArrayMutex);
	
	
	// Ora devo cominciare a leggere i dati dalla socket TCP inerenti alla bitmap creata
	QueryPerformanceFrequency(&freq);
	secsperline = 0;
	
	printf("Starting to read bitmap from network.\n");
	currenty = Job->rect.y1;
	//JobArray[i].currenty = currenty;
	render_bitmap_bpl = (RequestArray[a].size_x * 3 + 3) & ~3;
	linesize = (Job->rect.x2 - Job->rect.x1 + 1) * 3;
	
	MainBuffer = malloc( render_bitmap_bpl );
		
	    
	while ((currenty <= Job->rect.y2 ) && (JobArray[i].STOPTHREAD==0))
	{
		nread = 0; nread_tot = 0;
		
		// Conta il tempo
		QueryPerformanceCounter(&count1);
		
		while (nread_tot < linesize ) 
		{
			/*nread = recv(tcp_sock, &MainBuffer[nread_tot],
							((linesize - nread_tot) > (PICBUFSIZE-nread_tot) ?
							(PICBUFSIZE-nread_tot) :
							(linesize-nread_tot)), 0 );*/
			
			/*sock_arr.fd_count = 1;
			sock_arr.fd_array[0] = tcp_sock;
			Timeout.tv_sec = 5;
			Timeout.tv_usec = 0;
			if ((!select( 0,  &sock_arr, NULL, NULL, &Timeout))  )
			{
				nread = -1;
				break;
			}*/
			nread = recv(tcp_sock, &MainBuffer[nread_tot], (linesize-nread_tot), 0 );

			if (nread<=0) break;

			nread_tot += nread;
			   
		}
	    if (nread<=0) break;
		//Wait(BitmapMutex);
		//memcpy( &Job->bitmap[ currenty*W*3 + Job->rect.x1*3], MainBuffer, linesize);
		CopyMemory(&Job->bitmap[ currenty*render_bitmap_bpl + Job->rect.x1*3], MainBuffer, linesize);
		/*for (q = 0; q< linesize; q++)
		{
			Job->bitmap[q+currenty*W*3 + Job->rect.x1*3 ] = MainBuffer[q];
		}*/
		//Signal(BitmapMutex);

		// Aggiorno la finestra
		/*if ((currenty % 10)==0)
		{*/
			InvalidateRect(RequestArray[a].hWindow,NULL, FALSE);
			//UpdateWindow(RequestArray[a].hWindow);
		/*}*/

		// Conta il tempo e fa una stima del tempo rimasto
		QueryPerformanceCounter(&count2);
		diff.QuadPart = count2.QuadPart - count1.QuadPart;
		secsperline = (float) diff.QuadPart / (float) freq.QuadPart;
		//Wait(GlobalArrayMutex);
		//JobArray[i].currenty = currenty;
		JobArray[i].secsleft = (unsigned int) ceil ( (float) (Job->rect.y2 - currenty + 1) * secsperline) ;
		//Signal(GlobalArrayMutex);

		
		// Passo alla linea successiva
		currenty++;
	}
	// A questo punto ho appena letto tutta la bitmap oppure sono stato interrotto
	
	if ((JobArray[i].STOPTHREAD==1) && (currenty <= Job->rect.y2))
	{
		memset(&p, 0, PACKETSIZE);
		p.command = SLAVESTOP_COMMAND;
		p.datagram_id = GetNewJobId();

		Wait(GlobalArrayMutex);
		tx_count = 0;
		sendto(s, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in));
		memcpy( &(Job->LastPacketSent), &p, PACKETSIZE);
		Job->STOPTHREAD = 1;
		AddJobToArray( *Job );
		tx_count++;
		ReleaseMutex(GlobalArrayMutex);
	}
	

	if (nread<0)
	{
		Signal(GlobalArrayMutex);
		printf("Error %d: can't read from TCP socket.\n",WSAGetLastError());
		Fail (Job, i, s, tcp_sock, txtbuffer);
	}

	printf("Finished reading bitmap from network.\n");
	closesocket(tcp_sock);
	

	// Aspetto l'ultimo messaggio che sar un RENDERINGDONE o un RENDERINGSTOPPEDBYUSER
	// Se lo slave invia un comando di RENDERINGSTOPPEDBYUSER, affinch il coordinatore riesca a
	// leggerlo deve chiudere la sua socket in scrittura
	// Inoltre dovr comunicare in quale riga  arrivato con la variabile NEWLINE, vedere in fondo
	printf("Waiting completion command...\n");
	tx_count = 1;
	while ( (tx_count<3) && (WaitForSingleObject( Job->NewPacketEvent, 15000) == WAIT_TIMEOUT)  )
	{
		sendto(s, (char *) &(Job->LastPacketSent), PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in));
		tx_count++;
	}
	//printf("Error: %d\n",GetLastError());
	if ((tx_count >= 3) /*|| (JobArray[i].LastPacketReceived.command == RENDERINGFAILED_COMMAND)*/)
	{
		Fail( Job, i,s,0, txtbuffer);
	}
	ResetEvent(Job->NewPacketEvent);
	Wait(GlobalArrayMutex);
	memcpy(&Job->LastPacketReceived, &JobArray[i].LastPacketReceived, PACKETSIZE);
	printf("Received completion command.\n");

	
	memcpy( &newline, &JobArray[i].LastPacketReceived.data, sizeof(newline) );
	Signal(GlobalArrayMutex);

	if (JobArray[i].LastPacketReceived.command == RENDERINGFAILED_COMMAND)
	{
		sprintf(txtbuffer, "Request %d has failed, check files!", RequestArray[j].request_id);
		SetWindowText(RequestArray[j].hWindow, txtbuffer);
	}

	
	/*while ( (tx_count<3) && (WaitForSingleObject( Job->NewPacketEvent, 15000) == WAIT_TIMEOUT ) )
	{
		sendto(s, (char *) &(Job->LastPacketSent), PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in));
		tx_count++;
	}
	if (tx_count >= 3)
	{
		Fail( Job, i,s,0, txtbuffer);
	}
	ResetEvent(Job->NewPacketEvent);	
	memcpy(&Job->LastPacketReceived, &JobArray[i].LastPacketReceived, PACKETSIZE);
	*/

	
	/* if ( (Job->job_id) >= 3 )
	{
		Sleep( (Job->rect.x2 - Job->rect.x1) * 75 );
		newline = JobArray[i].rect.y2 + 1;
	}
	else
	{
		while (JobArray[i].STOPTHREAD == 0) Sleep(5000);
		newline = JobArray[i].rect.x1 + ((JobArray[i].rect.x2 - JobArray[i].rect.x1) / 2);
	} 
	*/


	// Termino il JOB, o perch ho finito, oppure perch il JOB viene fermato per fare la riallocazione

	printf("Job %d terminating %s...\n", Job->job_id, (JobArray[i].STOPTHREAD ? "forced by STOPTHREAD" : "") );
	
	WaitForSingleObject(GlobalArrayMutex, INFINITE);
	printf("Job %d acquired lock Global\n", Job->job_id);

	JobArray[i].status = JOB_DONE;                       /* Il job viene eliminato dalla lista dei jobs */
	Job->IndexInBox = IndexInBox( IDC_JOBLIST, Job->job_id);
	SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_DELETESTRING, (WPARAM) Job->IndexInBox, 0);
	memset(txtbuffer, 0, sizeof(txtbuffer));
	_snprintf(txtbuffer, sizeof(txtbuffer)-1, "Job %u (%u,%u)->(%u,%u) of Request %u [DONE]", 
				Job->job_id, Job->rect.x1, Job->rect.y1, Job->rect.x2, Job->rect.y2,Job->request_id );
	JobArray[i].IndexInBox = SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
	
	
	(Job->sl).status = FREE_SLAVE;
	SlaveTable(ST_ADD, &(Job->sl) );         /* Lo slave viene segnato di nuovo come libero  */

	
	Job->sl.IndexInBox = IndexInBox( IDC_SLAVELIST, Job->sl.IPaddress.S_un.S_addr );
	SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_DELETESTRING, (WPARAM) Job->sl.IndexInBox, 0);
	//Reinserire nella tabella lo slave!
	_snprintf(txtbuffer, sizeof(txtbuffer)-1, "%s power = %u [IDLE]", inet_ntoa(Job->sl.IPaddress), Job->sl.power  );
	Job->sl.IndexInBox = SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
	
	
	if (JobArray[i].STOPTHREAD == 0)
		SetEvent(JobTerminated_Event);
	else printf("Job stopped by scheduler, because there's a new free slave. Scheduler'last line = %d, Slave's last line = %d.\n", currenty, newline);
	
	CloseHandle(JobArray[i].NewPacketEvent);
	printf("Job %d releasing lock Global\n",Job->job_id);
	ReleaseMutex(GlobalArrayMutex);
	
	JobArray[i].STOPTHREAD = 0;
		
	ExitThread(currenty);
	return 0;
}

			   
int FindSlowestJobToEndIndex(void)
{
	int i = 0;
	int secs = 0;
	int last = i;

	while (fullJobArr[i]==0) i++;

	secs = JobArray[i].secsleft;

	while (i<MAX_JOBS)
	{
		if ((fullJobArr[i]) && (secs < JobArray[i].secsleft) && (JobArray[i].status==JOB_WORKING))
		{
			secs = JobArray[i].secsleft;
			last = i;
		}
		i++;
	}

	return last;
}

int FindMediumTimeToCompleteJobs(void)
{
	int MediumTime = 0;
	int sum = 0;
	int i = 0;
	int N = 0;

	while (i<MAX_JOBS)
	{
		if ((fullJobArr[i]) && (JobArray[i].status==JOB_WORKING) )
		{
			sum += JobArray[i].secsleft;
			N++;
		}
		i++;
	}

	MediumTime = sum / N;
	return MediumTime;
}


void ControllaElimina(unsigned int request_id)
{
	int found_nondone = 0, i = 0, j = 0;
	
	// Adesso devo cercare se questa richiesta ha degli altri job non-DONE, se i job sono tutti DONE allora la devo eliminare
	i = 0; found_nondone = 0;
	
	while (i<MAX_JOBS)
	{
		if (fullJobArr[i] && (JobArray[i].request_id == request_id) && (JobArray[i].status != JOB_DONE) && !found_nondone)
			found_nondone = 1;
		i++;
	}

	if (!found_nondone)
	{
		i = 0;
		while (i < MAX_REQUEST)
		{
			if (fullReqArr[i] && RequestArray[i].request_id == request_id) break;
			i++;
		}				// ora in i c' l'indice della richiesta che  terminata
		fullReqArr[i] = 0;
		RequestArray[i].IndexInBox = IndexInBox( IDC_REQUESTLIST, RequestArray[i].request_id );
		SendDlgItemMessage(hMainWindow, IDC_REQUESTLIST, LB_DELETESTRING, (WPARAM) RequestArray[i].IndexInBox, 0);

		j = 0;
		while (fullDoneReqArr[j]) j++;	//ora j  sulla prima posizione libera;
		fullDoneReqArr[j] = 1;
		memcpy(&DoneRequestArray[j], &RequestArray[i], sizeof(REQUEST));


		i = 0;
		while (i < MAX_JOBS)
		{
			if (fullJobArr[i] && (JobArray[i].request_id == request_id) )
			{
				fullJobArr[i] = 0;
				JobArray[i].IndexInBox = IndexInBox( IDC_JOBLIST, JobArray[i].job_id);
				SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_DELETESTRING, (WPARAM) JobArray[i].IndexInBox, 0);
			}
			i++;
		}
	}
	return;
}

			
DWORD WINAPI Scheduler(LPVOID lp)
{
	int  i =0, thread_id = 0, FreeSlave_no, j = 0, last = 0, k = 0, PendingJobs = 0,
		*PendingRectanglesWidthArray, FailedJobs = 0, *FailedRectanglesWidthArray,
		 nextline = 0, size = 0, WorkingJobs = 0, z = 0; int found_nondone = 0, wtid = 0;
	DWORD result;
	HANDLE HandleArray[4], fd;
		
	RECTANGLE rettangolo, *PendingRectanglesArray, *FailedRectanglesArray;
	
	SLAVE *FreeSlaveArray = NULL;
	JOB Job, *PendingJobsArray, *FailedJobsArray, *JobPointer;
		
	char txtbuffer[64];

	
	HandleArray[0] = NewRequest_Event;
	HandleArray[1] = JobTerminated_Event;  /* Ha autoreset automatico */
	HandleArray[2] = JobFailed_Event;              /* anche questo deve averlo */
	HandleArray[3] = NewSlaveHasArrived_Event;

	while(1)
	{
	  result = WaitForMultipleObjects( 4, HandleArray, FALSE, INFINITE /* 30000 */);
	/*  
		Il thread di ricezione ha il Mutex su NewRequest e riempie la struttura, poi lo rilascia.
	    Scheduler deve acquisire il lock, il thread di ricezione deve mettersi in attesa del rilascio
	*/

	  switch(result)
	  {
	  case (WAIT_OBJECT_0) :  
		{
			printf("New Request has arrived...\n");
			WaitForSingleObject(GlobalArrayMutex, INFINITE);

			i = 0;
			while (fullReqArr[i]) i++;									/* Cerca la prima posizione libera */
			memcpy( &RequestArray[i], &NewRequest, sizeof(REQUEST) ); /* Copia la NuovaRichiesta nella
	  															 prima posizione vuota del vettore
																 delle richieste pendenti */
			fullReqArr[i] = 1;

			RequestArray[i].request_id = GetNewRequestId();   /* La struct request  quasi completa, manca Status */
			RequestArray[i].bitmap_surface = malloc( 3 * RequestArray[i].size_x * (RequestArray[i].size_y + 16));
			memset(RequestArray[i].bitmap_surface, 0, 3 * RequestArray[i].size_x * (RequestArray[i].size_y + 16) );

			memset(&RequestArray[i].bitmap_info, 0, sizeof(RequestArray[i].bitmap_info) );
			RequestArray[i].bitmap_info.biSize = sizeof (BITMAPINFOHEADER) ;
			RequestArray[i].bitmap_info.biWidth = RequestArray[i].size_x ;
			RequestArray[i].bitmap_info.biHeight = RequestArray[i].size_y ;
			RequestArray[i].bitmap_info.biPlanes = 1 ;
			RequestArray[i].bitmap_info.biBitCount = 24 ;
			RequestArray[i].bitmap_info.biCompression = BI_RGB ;
		    RequestArray[i].bitmap_info.biClrUsed = 0 ;
			RequestArray[i].bitmap_info.biSizeImage = ((RequestArray[i].size_x*3 + 3) & ~3) * RequestArray[i].size_y ;
			RequestArray[i].bitmap_info.biClrImportant = 0 ;


			RequestArray[i].WindowThread = CreateThread( NULL, 0, WindowThread, &RequestArray[i].request_id, 0, &wtid);
			
			/* Devo copiare i file da TempArray a FileArray dandogli un ID univoco e azzerando poi
				TempFileArray e FullTempFileArray */
            
			  // Aggiungo i files all'array, e azzero le strutture TempFile
						z = 0;
						while (fullTempFileArr[z])
						{
							TempFileArray[z].file_id = GetNewFileId();
							fd = CreateFile( TempFileArray[z].name, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
							TempFileArray[z].size = GetFileSize(fd,NULL);
							CloseHandle(fd);
							TempFileArray[z].request_id = RequestArray[i].request_id;
   
							AddFileToArray(TempFileArray[z]);
							z++;
						}
						memset(TempFileArray, 0, sizeof(TempFileArray));
						memset(fullTempFileArr, 0, sizeof(fullTempFileArr) );
						


			FreeSlaveArray = SlaveTable(ST_GETFREEARRAY, NULL);
			FreeSlave_no = 0;
			while (FreeSlaveArray[FreeSlave_no].IPaddress.S_un.S_addr) FreeSlave_no++;
			/* Ottengo un array con gli slave disponibili, e li conto */

			if (FreeSlave_no == 0)
			{												/* Se non ho slave disponibili, segno la richiesta come pendente, ed aggiungo un job pendente */
				printf("New Request %d (%dx%d) is pending [NO FREE SLAVES]...\n",RequestArray[i].request_id,RequestArray[i].size_x,RequestArray[i].size_y);
				
				
				RequestArray[i].status = REQ_PENDING;

				Job.rect.y1 = 0; Job.rect.y2 = RequestArray[i].size_y - 1;
				Job.rect.x1 = 0; Job.rect.x2 = RequestArray[i].size_x - 1;
				Job.rect.request_id = RequestArray[i].request_id;
				Job.request_id = RequestArray[i].request_id; 
				Job.STOPTHREAD = 0;
				Job.bitmap = RequestArray[i].bitmap_surface;
				Job.secsleft = 0;

				Job.job_id = GetNewJobId();
				Job.rect.job_id = Job.job_id;
				Job.status = JOB_PENDING;
				Job.ServingThread = 0;
				Job.IndexInBox = -1;

				AddJobToArray(Job);

				
			}
			else
			{
				printf("New Request %d (%dx%d) is now working...\n",RequestArray[i].request_id,RequestArray[i].size_x,RequestArray[i].size_y);
				
				RequestArray[i].status = REQ_WORKING;    /* Segno la richiesta come in opera */
		
				rettangolo.request_id = RequestArray[i].request_id;
				rettangolo.x1 = 0; rettangolo.y1 = 0;
				rettangolo.x2 = RequestArray[i].size_x - 1;
				rettangolo.y2 = RequestArray[i].size_y - 1;

				Time = FLT_MAX;
				CreaMatriceAllocazione( x, FreeSlave_no-1, 1, FreeSlave_no, &NewRequest.size_x, out, FreeSlaveArray, &rettangolo);
				/*  cont = cycle_matrix4(x, M-1,   N, M, widtharray, out, slavearray, rectanglearray);  */

				/* Ora dentro out ho lo schema di allocazione del carico, che devo distribuire. Devo anche aggiornare le
				liste globali di slaves, jobs, richieste, etc.
				*/
		
		
				Job.rect.y1 = 0; Job.rect.y2 = RequestArray[i].size_y - 1;
				Job.rect.x1 = 0; Job.rect.x2 = -1;
				Job.rect.request_id = RequestArray[i].request_id;
				Job.request_id = RequestArray[i].request_id; 
				Job.STOPTHREAD = 0;
				Job.bitmap = RequestArray[i].bitmap_surface;
				Job.secsleft = 0;
				Job.IndexInBox = -1;
		

				for (j=0; j < FreeSlave_no; j++)
				{
					Job.rect.x1 = Job.rect.x2 + 1 ;
					Job.rect.x2 = Job.rect.x1 + out[0][j] - 1;
					Job.job_id = GetNewJobId();
					Job.rect.job_id = Job.job_id;
					Job.status = JOB_WORKING;
					Job.ServingThread = 0;
					
					FreeSlaveArray[j].status = WORKING_SLAVE;
					memcpy( &Job.sl,  &FreeSlaveArray[j], sizeof(SLAVE) );
					SlaveTable( ST_ADD, &FreeSlaveArray[j]);
					
					Job.NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
					
					JobPointer = malloc(sizeof(JOB));
					memcpy(JobPointer, &Job, sizeof(JOB));

					Job.ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);  
																							
					AddJobToArray(Job);
				}
			}
			
			
			SetEvent(HandledNewRequestEvent);
			
			memset(txtbuffer, 0, sizeof(txtbuffer));
			_snprintf(txtbuffer, sizeof(txtbuffer)-1, "Request %u (%ux%u) [%s]", 
					  RequestArray[i].request_id, RequestArray[i].size_x,RequestArray[i].size_y,
					  (FreeSlave_no ? "WORKING" : "PENDING") );
			RequestArray[i].IndexInBox = SendDlgItemMessage(hMainWindow, IDC_REQUESTLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
			
			if (FreeSlave_no==0)
			{
				memset(txtbuffer, 0, sizeof(txtbuffer));
				_snprintf(txtbuffer, sizeof(txtbuffer)-1, "Job %u (%u,%u)->(%u,%u) of Request %u [PENDING]", 
						  Job.job_id, Job.rect.x1, Job.rect.y1, Job.rect.x2, Job.rect.y2,Job.request_id );
				Job.IndexInBox = SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
				AddJobToArray(Job);
			}


			

			ReleaseMutex(GlobalArrayMutex);

			break;
		}
	  case (WAIT_OBJECT_0 + 1) :
	  case (WAIT_OBJECT_0 + 3) :
		{
			WaitForSingleObject(GlobalArrayMutex, INFINITE);
			if (result==1)
			{
				printf("JobStopped_Event Detected  & Scheduler acquired lock\n");
				ResetEvent(JobTerminated_Event);
			}

			i = 0; PendingJobs = 0;
			while (i<MAX_JOBS)
			{
				if ( (fullJobArr[i]) && ( (JobArray[i].status == JOB_PENDING) || (JobArray[i].status == JOB_FAILED ) ) )
				{
					PendingJobs++;
					last = i;
				}
				i++;
			}

			if (PendingJobs)
			{
				
				/* Se entro qui nel caso in cui un job  terminato, devo ricordarmi di togliere il job dalla lista
					settando a 0 il vettore fullJobArray. Lo Slave corrispondente  invece gi stato marcato come libero */
				
				    
				if (result == (WAIT_OBJECT_0 + 1) )
				{
					i = 0;
					while (!(fullJobArr[i] && (JobArray[i].status == JOB_DONE) ) ) i++;
					// porta l'indice nella posizione del job terminato 
					//fullJobAddr[i] = 0;
					ControllaElimina(JobArray[i].request_id);          // Ho eliminato il job terminato e la sua richiesta, se  completata
				}
				
				
				FreeSlaveArray = SlaveTable(ST_GETFREEARRAY, NULL);
				FreeSlave_no = 0;
				while (FreeSlaveArray[FreeSlave_no].IPaddress.S_un.S_addr) FreeSlave_no++;
				/* Ottengo un array con gli slave disponibili, e li conto (sicuramente ce ne deve essere uno, visto che  terminato*/

				PendingJobsArray = malloc( PendingJobs* sizeof(JOB) );
				PendingRectanglesArray = malloc( PendingJobs* sizeof(RECTANGLE) );
				PendingRectanglesWidthArray = malloc( PendingJobs * sizeof(int) );
				j = 0;
				for (i = 0; i<=last; i++)
				{
					if ( (fullJobArr[i]) && ((JobArray[i].status == JOB_PENDING)||(JobArray[i].status == JOB_FAILED)) )
					{
						memcpy(&PendingJobsArray[j], &JobArray[i], sizeof(JOB));
						memcpy(&PendingRectanglesArray[j], &JobArray[i].rect, sizeof(RECTANGLE) );
						PendingRectanglesWidthArray[j] = PendingRectanglesArray[j].x2 - PendingRectanglesArray[j].x1 + 1; 
						j++;
					}
				}				/* A questo punto ho un array con i job pendenti e i rettangoli*/

				if (PendingJobs>FreeSlave_no) PendingJobs = FreeSlave_no;
				/* Se ho pi richieste pendenti di quanti processori sono disponibili, ignoro le ultime */


				/* Devo chiamare la routine di allocazione con gli slaves liberi, e una lista di rettangoli */
				Time = FLT_MAX;
				CreaMatriceAllocazione( x, FreeSlave_no - 1, PendingJobs, FreeSlave_no, PendingRectanglesWidthArray, out, FreeSlaveArray, PendingRectanglesArray);
				
				for (i=0; i<PendingJobs; i++)
				{
					j = 0;

						
						/* while Occorre anche modificare lo stato della richiesta in REQUEST_WORKING oltre che quello del JOB */
						k = 0;
						while (k<MAX_REQUEST)
						{
							if (fullReqArr[k] && (RequestArray[k].request_id == PendingJobsArray[i].request_id)) break;
							k++;
						}                  /* Ora k  l'indice nell'array delle richieste */
						RequestArray[k].status = REQ_WORKING;
			
						RequestArray[k].IndexInBox = IndexInBox( IDC_REQUESTLIST, RequestArray[k].request_id);
						SendDlgItemMessage(hMainWindow, IDC_REQUESTLIST, LB_DELETESTRING, (WPARAM) RequestArray[k].IndexInBox, 0);
			

						memset(txtbuffer, 0, sizeof(txtbuffer));
						_snprintf(txtbuffer, sizeof(txtbuffer)-1, "Request %u (%ux%u) [WORKING]", 
									RequestArray[k].request_id, RequestArray[k].size_x,RequestArray[k].size_y);
						RequestArray[k].IndexInBox = SendDlgItemMessage(hMainWindow, IDC_REQUESTLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);
			


					while ((out[i][j] == 0) && (j<FreeSlave_no)) j++;
					if (j<FreeSlave_no)
					{
						PendingJobsArray[i].status = JOB_WORKING;
						PendingJobsArray[i].secsleft = 0;
						
						PendingJobsArray[i].rect.x2 = out[i][j] -1 ;

						FreeSlaveArray[j].status = WORKING_SLAVE;
						memcpy( &PendingJobsArray[i].sl, &FreeSlaveArray[j], sizeof(SLAVE) );
						
						SlaveTable(ST_ADD, &FreeSlaveArray[j] );

						
						PendingJobsArray[i].ServingThread = 0;
						PendingJobsArray[i].NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

						JobPointer = malloc(sizeof(JOB));
   						memcpy(JobPointer, &PendingJobsArray[i], sizeof(JOB));
						
						
						PendingJobsArray[i].ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);  
																			
			
						AddJobToArray(PendingJobsArray[i]);


					/* il codice non testato si trovava qui */

					}
					j++;
					
					
					while (j<FreeSlave_no)
					{
						if (out[i][j])
						{
							PendingJobsArray[i].status = JOB_WORKING;
							PendingJobsArray[i].secsleft = 0;
						
							PendingJobsArray[i].rect.x1 = PendingJobsArray[i].rect.x2 + 1;
							PendingJobsArray[i].rect.x2 = PendingJobsArray[i].rect.x1 + out[i][j] -1 ;
							PendingJobsArray[i].job_id = GetNewJobId();

							FreeSlaveArray[j].status = WORKING_SLAVE;
							memcpy( &PendingJobsArray[i].sl, &FreeSlaveArray[j], sizeof(SLAVE) );
							SlaveTable(ST_ADD, &FreeSlaveArray[j] );
	
	
							PendingJobsArray[i].ServingThread = 0;
							PendingJobsArray[i].NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
							JobPointer = malloc(sizeof(JOB));
							memcpy(JobPointer, &PendingJobsArray[i], sizeof(JOB));
								
							PendingJobsArray[i].ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id); 
																				
							AddJobToArray(PendingJobsArray[i]);
						}
						j++;
					}
				}
				free(PendingRectanglesWidthArray);
				free(PendingRectanglesArray);
				free(PendingJobsArray);
			}				
			else
				if (result == (WAIT_OBJECT_0 + 1) )
				{   
					/* Se sono qui vuol dire che  terminato un JOB, e sar quello con l'attributo 
						JOB_DONE   */
					i=0; WorkingJobs = 0;
					while (i<MAX_JOBS) 
					{
						if ((fullJobArr[i]) && (JobArray[i].status == JOB_WORKING) ) WorkingJobs++;
						i++;
					}

					if (WorkingJobs == 0)
					{
						i = 0;
						while (!(fullJobArr[i] && (JobArray[i].status == JOB_DONE))) i++; /* i  l'indice del JOB_DONE */
						//fullJobArr[i] = 0;
						ControllaElimina(JobArray[i].request_id);
	
						ReleaseMutex(GlobalArrayMutex);
						break;
					}
			

					i = 0;
					while ( (i<MAX_JOBS) && ( !(fullJobArr[i] && (JobArray[i].status == JOB_DONE)) )) i++;
					/* porta l'indice nella posizione del job terminato */
					if (i==MAX_JOBS)
					{
						ReleaseMutex(GlobalArrayMutex);
						break;
					}

					FreeSlaveArray = malloc( 2* sizeof(SLAVE) );
					memset(FreeSlaveArray, 0, 2* sizeof(SLAVE) );

					memcpy(&FreeSlaveArray[0], &JobArray[i].sl, sizeof(SLAVE) );
						/* Lo slave del job appena terminato  ora libero */

					//fullJobArr[i] = 0;
							/* Tolgo il job dalla lista dei jobs, poich  concluso */

					ControllaElimina(JobArray[i].request_id);   // tolgo il job concluso dalla lista dei job e
																// controllo se anche la corrispondente richiesta  stata completata
				
					FreeSlave_no = 2;
					
							/*Rialloca ii/i jobs pi lenti */
					i = FindSlowestJobToEndIndex();
					j = FindMediumTimeToCompleteJobs();
					if ( (JobArray[i].secsleft > TIME_LIMIT) &&   
						 (
							(
								(JobArray[i].secsleft >= (COEFF_VARIANZA * j)) &&
								(WorkingJobs > 1)
							) ||
							( WorkingJobs==1 )
						 )
					   )   /* altrimenti non vale la pena a riallocare */
					{
						memcpy(&FreeSlaveArray[1], &JobArray[i].sl, sizeof(SLAVE) );
							/* l'altro slave libero  quello relativo al job che fermo */
						
						JobArray[i].STOPTHREAD = 1;
						ReleaseMutex(GlobalArrayMutex);
							/* Devo rilasciare i mutex, in quanto se il thread fosse sospeso su uno di questi
							   andrei in deadlock */
							
						WaitForSingleObject(JobArray[i].ServingThread, INFINITE);
						GetExitCodeThread(JobArray[i].ServingThread, &nextline);
							/* Il thread deve ritornare la linea da renderizzare, e deve anche aggiustare
							   la tabella degli slave segnalando che lo slave  ancora occupato
							*/

							/* Appena il thread termina, riacquisto i semafori */
						
						WaitForSingleObject(GlobalArrayMutex, INFINITE);


						JobArray[i].rect.y1 = nextline;
						size = JobArray[i].rect.x2 - JobArray[i].rect.x1 + 1;

						Time = FLT_MAX;
						CreaMatriceAllocazione( x, 1, 1, 2, &size, out, FreeSlaveArray, &JobArray[i].rect);
				
						if ((out[0][0]) || ( (out[0][0]==0) && (out[0][1]) ) )
						{
							// Il primo a riprendere mantiene il vecchio JobId
							JobArray[i].rect.x2 = JobArray[i].rect.x1 + ( out[0][0] ? out[0][0] : out[0][1] ) - 1;
							JobArray[i].status = JOB_WORKING;
							JobArray[i].STOPTHREAD = 0;
							JobArray[i].secsleft = 0;
							memcpy(&JobArray[i].sl, &FreeSlaveArray[ (out[0][0] ? 0 : 1) ], sizeof(SLAVE));

							JobArray[i].sl.status = WORKING_SLAVE;
							SlaveTable(ST_ADD, &(JobArray[i].sl) );

							
							JobArray[i].ServingThread = 0;
							
							JobArray[i].NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
							JobPointer = malloc(sizeof(JOB));
							memcpy(JobPointer, &JobArray[i], sizeof(JOB));
						
							JobArray[i].ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);   
																				
						}
						if ((out[0][1]) && (out[0][0]) )
						{
							// Se c', il secondo acquisisce un nuovo JobId
							memcpy(&Job, &JobArray[i], sizeof(JOB) );
							Job.job_id = GetNewJobId();
							Job.rect.x1 = Job.rect.x2 + 1;
							Job.rect.x2 = Job.rect.x1 + out[0][1] - 1;
							memcpy(&Job.sl, &FreeSlaveArray[1], sizeof(SLAVE));

							Job.sl.status = WORKING_SLAVE;
							SlaveTable(ST_ADD, &Job.sl);
							
							Job.ServingThread = 0;
							Job.NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
							JobPointer = malloc(sizeof(JOB));
							memcpy(JobPointer, &Job, sizeof(JOB));

							
							Job.ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);   
																				
							AddJobToArray(Job);
						}

						/*PulseEvent(StartThreadsEvent);*/
/*						SetEvent(StartThreadsEvent);*/
					}
					free(FreeSlaveArray);
				}

				else
				{
					// Vuol dire che  arrivato un nuovo slave ed ho anche dei job che lavorano
					i=0; WorkingJobs = 0;
					while (i<MAX_JOBS) 
					{
						if ((fullJobArr[i]) && (JobArray[i].status == JOB_WORKING) ) WorkingJobs++;
						i++;
					}

					if (WorkingJobs == 0)
					{
						// Se non ho job che lavorano ed entra un nuovo slave non faccio nulla
						ReleaseMutex(GlobalArrayMutex);
						break;
					}

					FreeSlaveArray = SlaveTable(ST_GETFREEARRAY, NULL);
					FreeSlave_no = 0;
					while (FreeSlaveArray[FreeSlave_no].IPaddress.S_un.S_addr) FreeSlave_no++;
					/* Ottengo un array con gli slave disponibili, e li conto (sicuramente ce ne deve
						essere uno, visto che uno  appena arrivato		 */
					FreeSlave_no++;   		

					
					// Fermo il job pi lento
					i = FindSlowestJobToEndIndex();
					j = FindMediumTimeToCompleteJobs();
					if ( (JobArray[i].secsleft > TIME_LIMIT) &&   
						 (
							(
								(JobArray[i].secsleft >= (COEFF_VARIANZA * j)) &&
								(WorkingJobs > 1)
							) ||
							( WorkingJobs==1 )
						 )
					   )   /* altrimenti non vale la pena a riallocare */
					{
						// devo riallocare il job i
						memcpy(&FreeSlaveArray[FreeSlave_no-1], &JobArray[i].sl, sizeof(SLAVE) );
							/* l'altro slave libero  quello relativo al job che fermo, e lo metto 
								in ultima posizione  */
						
						JobArray[i].STOPTHREAD = 1;
						ReleaseMutex(GlobalArrayMutex);
						/* Devo rilasciare i mutex, in quanto se il thread fosse sospeso su uno di questi
					       andrei in deadlock */
							
						WaitForSingleObject(JobArray[i].ServingThread, INFINITE);
						GetExitCodeThread(JobArray[i].ServingThread, &nextline);
					    // Ho appena fermato il job i che mi ha comunicato quale  la nuova linea da renderizzare


						WaitForSingleObject(GlobalArrayMutex, INFINITE);

						JobArray[i].rect.y1 = nextline;
						size = JobArray[i].rect.x2 - JobArray[i].rect.x1 + 1;

						Time = FLT_MAX;
						CreaMatriceAllocazione( x, FreeSlave_no-1,1, FreeSlave_no, &size, out, FreeSlaveArray, &JobArray[i].rect);
		

				
						j = 0;
						while ((out[0][j] == 0) && (j<FreeSlave_no)) j++;
					
						if (j<FreeSlave_no)
						{
							// il primo job a partire mantiene la stessa id
							JobArray[i].rect.x2 = JobArray[i].rect.x1 + out[0][j] - 1;
							JobArray[i].status = JOB_WORKING;

							JobArray[i].STOPTHREAD = 0;

							JobArray[i].secsleft = 0;
							
							memcpy(&JobArray[i].sl, &FreeSlaveArray[j ], sizeof(SLAVE));		
						
							JobArray[i].sl.status = WORKING_SLAVE;
							SlaveTable(ST_ADD, &(JobArray[i].sl) );


							JobArray[i].ServingThread = 0;
							JobArray[i].NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

							memcpy(&Job, &JobArray[i], sizeof(JOB) );

							JobPointer = malloc(sizeof(JOB));
							memcpy(JobPointer, &Job, sizeof(JOB));

							Job.ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);  
							AddJobToArray(Job);
						}
	
						j++;

						while (j<FreeSlave_no)
						{
							if (out[0][j])
							{
	  			                // Se ci sono, il secondo e i successivi acquisiscono un nuovo JobId
								memcpy(&Job, &JobArray[i], sizeof(JOB) );

								Job.job_id = GetNewJobId();
								Job.rect.x1 = Job.rect.x2 + 1;
								Job.rect.x2 = Job.rect.x1 + out[0][j] - 1;
								memcpy(&Job.sl, &FreeSlaveArray[j], sizeof(SLAVE));

								Job.sl.status = WORKING_SLAVE;
								SlaveTable(ST_ADD, &Job.sl);
							
								Job.ServingThread = 0;
								Job.NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
								JobPointer = malloc(sizeof(JOB));
								memcpy(JobPointer, &Job, sizeof(JOB));

								Job.ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);
		 						AddJobToArray(Job);
							}
						j++;
						}	
					}

					free(FreeSlaveArray);
				}
								
			/*ReleaseMutex(JobArrayMutex);
			ReleaseMutex(RequestArrayMutex);*/
			printf("Scheduler relasing lock on global\n");
			ReleaseMutex(GlobalArrayMutex);
			/*if (result== (WAIT_OBJECT_0 + 3)) ResetEvent(NewSlaveHasArrived_Event);*/
			break;
		}


	  case (WAIT_OBJECT_0 + 2):
		{
			/*WaitForSingleObject(RequestArrayMutex, INFINITE);
			WaitForSingleObject(JobArrayMutex, INFINITE);*/
/*			h[0] = RequestArrayMutex;
			h[1] = JobArrayMutex;
			WaitForMultipleObjects(2, h, TRUE, INFINITE);*/
			WaitForSingleObject(GlobalArrayMutex, INFINITE);

			
			
			/* devo cercare tutti i job falliti e riallocarli, ed eventualmente rimetterli come pendenti */
			FreeSlaveArray = SlaveTable(ST_GETFREEARRAY, NULL);
			FreeSlave_no = 0;
			while (FreeSlaveArray[FreeSlave_no].IPaddress.S_un.S_addr) FreeSlave_no++;
			/* Ottengo un array con gli slave disponibili, e li conto*/
			/* Posso riallocare, se ho M slaves disponibili, fino a M JOB_FAILED, gli altri dovr segnarli
				come JOB_PENDING  */

			i = 0; FailedJobs = 0;
			while ( (i<MAX_JOBS) && (FailedJobs<FreeSlave_no) )
			{
				if ((fullJobArr[i]) && (JobArray[i].status == JOB_FAILED) )
				{
					last = i;
					FailedJobs++;
				}
				i++;
			}

			while (i<MAX_JOBS)
			{
				if ((fullJobArr[i]) && (JobArray[i].status == JOB_FAILED) )
					JobArray[i].status = JOB_PENDING;
				i++;
			}
			
			if (FreeSlave_no == 0)
			{
				Signal(GlobalArrayMutex);
				break;
			}

			FailedJobsArray = malloc( FailedJobs* sizeof(JOB) );
			FailedRectanglesArray = malloc( FailedJobs* sizeof(RECTANGLE) );
			FailedRectanglesWidthArray = malloc( FailedJobs * sizeof(int) );
			j = 0;
			for (i = 0; i<=last; i++)
			{
				if ( (fullJobArr[i]) && (JobArray[i].status == JOB_FAILED) )
				{
					memcpy(&FailedJobsArray[j], &JobArray[i], sizeof(JOB));
					memcpy(&FailedRectanglesArray[j], &JobArray[i].rect, sizeof(RECTANGLE) );
					FailedRectanglesWidthArray[j] = FailedRectanglesArray[j].x2 - FailedRectanglesArray[j].x1 + 1; 
					j++;
				}
			}				/* A questo punto ho un array con i job pendenti e i rettangoli e le ampiezze*/


			/* Devo chiamare la routine di allocazione con gli slaves liberi, e una lista di rettangoli */
			Time = FLT_MAX;
			CreaMatriceAllocazione( x, FreeSlave_no - 1, FailedJobs, FreeSlave_no, FailedRectanglesWidthArray, out, FreeSlaveArray, FailedRectanglesArray);
			
				
			for (i=0; i<FailedJobs; i++)
			{
				j = 0;
				while ((out[i][j] == 0) && (j<FreeSlave_no)) j++;
				if (j<FreeSlave_no)
				{
					FailedJobsArray[i].status = JOB_WORKING;
					FailedJobsArray[i].secsleft = 0;
					
					FailedJobsArray[i].rect.x2 = out[i][j] -1 ;

					FreeSlaveArray[j].status = WORKING_SLAVE;
					memcpy( &FailedJobsArray[i].sl, &FreeSlaveArray[j], sizeof(SLAVE));
					SlaveTable(ST_ADD, &FreeSlaveArray[j] );
	

					FailedJobsArray[i].ServingThread = 0;
					FailedJobsArray[i].NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
					JobPointer = malloc(sizeof(JOB));
					memcpy(JobPointer, &FailedJobsArray[i], sizeof(JOB));

					
					FailedJobsArray[i].ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);   
																		
	
					AddJobToArray(FailedJobsArray[i]);            /* Il job, se viene scomposto in N jobs, deve creare solo N-1 NUOVI jobs */
				}
				j++;
					
					
				while (j<FreeSlave_no)
				{
					if (out[i][j])
					{
						FailedJobsArray[i].status = JOB_WORKING;
						FailedJobsArray[i].secsleft = 0;
					
						FailedJobsArray[i].rect.x1 = FailedJobsArray[i].rect.x2 + 1;
						FailedJobsArray[i].rect.x2 = FailedJobsArray[i].rect.x1 + out[i][j] -1 ;
						FailedJobsArray[i].job_id = GetNewJobId();
			
						FreeSlaveArray[j].status = WORKING_SLAVE;
						memcpy( &FailedJobsArray[i].sl, &FreeSlaveArray[j], sizeof(SLAVE) );
						SlaveTable(ST_ADD, &FreeSlaveArray[j] );
	
	
						FailedJobsArray[i].ServingThread = 0;
						FailedJobsArray[i].NewPacketEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
						JobPointer = malloc(sizeof(JOB));
						memcpy(JobPointer, &Job, sizeof(JOB));

						FailedJobsArray[i].ServingThread = CreateThread( NULL, 0, DoJob, JobPointer, 0, &thread_id);   
																			
						AddJobToArray(FailedJobsArray[i]);
					}
					j++;
				}
			}
			free(FailedRectanglesWidthArray);
			free(FailedRectanglesArray);
			free(FailedJobsArray);
			ReleaseMutex(GlobalArrayMutex);
			break;
		}

	  case WAIT_TIMEOUT :
			{
				break;
			}



	  default :
		{
			printf("Scheduler encountered unknown situation?!?!? (%d)\n",result);
			break;
		}
	  }
	}
	
	ExitThread(0);
	return 0;



}



				

DWORD WINAPI receiving_thread(SOCKET *s2)		/* Si mette in ascolto su una socket s2, gi inizializzata e bound */
{
	struct sockaddr_in from_host;
	int size = sizeof(struct sockaddr), nread = 0, i, MustStay = 1;
	unsigned int LastReceivedPacket_id = 0;

	SLAVE sl, tempsl;
	PACKET incoming_packet,iamalive_packet,callforslaves_packet;
	char txtbuffer[64];
	
	//NewRequest_Event = CreateEvent(NULL, TRUE, FALSE, NULL);

	memset(&iamalive_packet, 0, PACKETSIZE);
	iamalive_packet.command = IAMALIVE_COMMAND;

	memset(&callforslaves_packet, 0, PACKETSIZE);
	callforslaves_packet.command = CALLFORSLAVES_COMMAND;
	
	do
	{
		memset( &incoming_packet,0,sizeof(incoming_packet));
		memset( (char *) &from_host, 0, sizeof(struct sockaddr_in));

		nread = recvfrom(*s2, (char *) &incoming_packet, sizeof(incoming_packet), 0, (struct sockaddr *) &from_host, &size );
		if (nread<0)
		{
			printf("Errore %d su recvfrom (%d)\n", WSAGetLastError(), nread );
			MustStay = 0;
			/* Rispedire l'ultimo pacchetto inviato */
		}

		
		switch (incoming_packet.command)
		{
			case ADDNODE_COMMAND :
			{
				memset(&tempsl, 0, sizeof(SLAVE));
				memcpy(&tempsl.IPaddress, &from_host.sin_addr, sizeof(struct sockaddr_in));

				SlaveTable(ST_LOOKUPNODE, &tempsl);
				if (tempsl.IPaddress.s_addr == 0)
				{
					sl.IPaddress.s_addr = from_host.sin_addr.s_addr;
					sl.power = *( (int *) incoming_packet.data);
					sl.status = FREE_SLAVE;
				
					printf("New Slave arrived (%s).\n",inet_ntoa(sl.IPaddress));
					memset(txtbuffer, 0, sizeof(txtbuffer));
					_snprintf(txtbuffer, sizeof(txtbuffer)-1, "%s, power = %u [IDLE]", inet_ntoa(sl.IPaddress), sl.power );

					WaitForSingleObject(GlobalArrayMutex, INFINITE);
					SetEvent(NewSlaveHasArrived_Event);
					sl.IndexInBox = SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);

					SlaveTable(ST_ADD, &sl);
					ReleaseMutex(GlobalArrayMutex);
				}
				break;
			}

			case AREYOUALIVE_COMMAND :
			{
				from_host.sin_port = SLAVE_UDP_PORT;
				sendto( *s2, (char *) &iamalive_packet, PACKETSIZE, 0, (struct sockaddr *) &from_host, sizeof(struct sockaddr_in) );
				break;
			}

			case CALLFORMASTER_COMMAND :
			{/*
				from_host.sin_port = SLAVE_UDP_PORT;
				sendto(*s2, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &from_host, sizeof(struct sockaddr_in) );*/
				break;
			}

			case SLAVEABORT_COMMAND :
			{
				// Guardo se lo slave  gi noto
				memset(&tempsl, 0, sizeof(SLAVE));
				memcpy(&tempsl.IPaddress, &from_host.sin_addr, sizeof(struct sockaddr_in));

				SlaveTable(ST_LOOKUPNODE, &tempsl);
				if (tempsl.IPaddress.s_addr != 0)
				{
					Wait(GlobalArrayMutex);
					i = IndexInBox( IDC_SLAVELIST, tempsl.IPaddress.s_addr );
					SendDlgItemMessage(hMainWindow, IDC_SLAVELIST, LB_DELETESTRING, (WPARAM) i, 0);
					SlaveTable(ST_DELETE, &tempsl);
					
					// se lo slave  gi registrato al coordinatore
					switch (tempsl.status)
					{
						case FREE_SLAVE:
							break;

						case WORKING_SLAVE:
							i = 0;
							while (i<MAX_JOBS)
							{
								if ( fullJobArr[i] && (JobArray[i].sl.IPaddress.s_addr == tempsl.IPaddress.s_addr) ) break;
								i++;
							}				// in i ora c' l'indice nel vettore dei job
							if (i==MAX_JOBS) break;

							//memcpy( &Job, &JobArray[i], sizeof(JOB) );
							printf("Slave %s said it has failed.\n",inet_ntoa(tempsl.IPaddress));
							
							TerminateThread(JobArray[i].ServingThread, 0);
							JobArray[i].status = JOB_FAILED;
							JobArray[i].IndexInBox = IndexInBox(IDC_JOBLIST, JobArray[i].job_id);
							SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_DELETESTRING, (WPARAM) JobArray[i].IndexInBox, 0);
							memset(txtbuffer, 0, sizeof(txtbuffer));
							_snprintf(txtbuffer, sizeof(txtbuffer)-1, "Job %u (%u,%u)->(%u,%u) of Request %u [FAILED]", 
											JobArray[i].job_id, JobArray[i].rect.x1, JobArray[i].rect.y1, JobArray[i].rect.x2, JobArray[i].rect.y2,JobArray[i].request_id );
							JobArray[i].IndexInBox = SendDlgItemMessage(hMainWindow, IDC_JOBLIST, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) txtbuffer);

							SetEvent(JobFailed_Event);
							break;
					}
					Signal(GlobalArrayMutex);
				}
				break;
			}
					
	
			
			default :
			{
				WaitForSingleObject(GlobalArrayMutex,INFINITE);
				i = IndexInJobArrayFromAddress(from_host.sin_addr);
				if ((i == -1) /*||(JobArray[i].status != JOB_WORKING)*/ )
				{
					Signal(GlobalArrayMutex);
					continue;
				}
				/*if (incoming_packet.command == CALLFORMASTER_COMMAND)
				{
					Signal(GlobalArrayMutex);
					continue;
				}*/
				memcpy( &JobArray[i].LastPacketReceived, &incoming_packet, PACKETSIZE);
				SetEvent( JobArray[i].NewPacketEvent );
				ReleaseMutex(GlobalArrayMutex);
			}
		}

		
	
	} while( /*strcmp(incoming_packet.data,"stop") &&*/ MustStay);

	ExitThread(0);
	return 0;
}




int main(int argc, char *argv[])
{
	WNDCLASS wc;
	
	SetConsoleTitle("dPoV - Distributed PoV [COORDINATOR MODULE] - Console Output");

	printf("\ndPoV - Distributed Persistence of Vision Ray Tracer\t   by Aldo Romani, 2001\n");
	printf("===================================================\n");
	printf("COORDINATOR MODULE.\nCode based on Persistence of Vision Raytracer(tm)\n[Copyright 1996-1999 Persistence of Vision Team]\n");
	printf("* This work is based on the free distribution code, and is freely available too\n");
	printf("* The new code implements support for network load sharing and balancing \n");
	printf("* The terms POV-Ray, POV, and Persistence of Vision Raytracer are trademarks\n* of the Persistence of Vision Team.\n\n");
 


	hInst = GetModuleHandle(NULL);

	wc.style         = CS_BYTEALIGNCLIENT /*| CS_VREDRAW | CS_HREDRAW;*/;
    wc.lpfnWndProc   = Request_Window_Procedure ;
    wc.cbClsExtra    = 0 ;
    wc.cbWndExtra    = 0 ;
    wc.hInstance     = hInstance ;
    wc.hIcon         = NULL ;
    wc.hCursor       = NULL ;
    wc.hbrBackground = /*NULL ;*/ (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName  = NULL ;
    wc.lpszClassName = "request_window" ;
    if (RegisterClass (&wc) == FALSE)
      return (FALSE) ;

    /*hMainWindow = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DPOVCONTROL), NULL, (DLGPROC) MainWindowProc);*/
	// Creo una finestra di dialogo modeless
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DPOVCONTROL), NULL, (DLGPROC) MainWindowProc);
	ShowWindow(hMainWindow, SW_SHOW); 
	
	TerminateThread(Receiver, 0);
	TerminateThread(Sched, 0);

	WSACleanup();

	return 0;	
}