#define MAX_REQUEST 16
#define MAX_JOBS 64
#define MAX_FILES 128
#define MAX_SLAVES 16

#define PACKETSIZE (sizeof(PACKET))
#define ADDNODE_COMMAND 1
#define CALLFORSLAVES_COMMAND 2
#define GETFILES_COMMAND 3
#define CALLFORMASTER_COMMAND 4
#define AREYOUALIVE_COMMAND 5
#define IAMALIVE_COMMAND 6
#define SLAVEABORT_COMMAND 7
#define ALREADYHAVE_COMMAND 8
#define DONTHAVE_COMMAND 9
#define STARTRENDERING_COMMAND 10
#define RENDERINGDONE_COMMAND 11
#define DELETENODE_COMMAND 12
#define SLAVEQUIT_COMMAND 13
#define SLAVESTOP_COMMAND 14
#define RENDERINGSTOPPED_COMMAND 15
#define RENDERINGFAILED_COMMAND 16
#define SLAVEKILL_COMMAND 17
//#define RENDERINGSTARTED_COMMAND 10



#define ST_INIT 0
#define ST_ADD 1
#define ST_DELETE 2
#define ST_UNLOAD 3
#define ST_PRINT 4
#define ST_LOCK 5
#define ST_UNLOCK 6
#define ST_RESET 7
#define ST_GETNEXT 8
#define ST_LOOKUPNODE 9
#define ST_GETARRAY 10
#define ST_GETFREEARRAY 11
#define ST_GETFAILEDARRAY 12
#define ST_CLEARALL 13

#define MUTEX_INIT 0


#define FREE_SLAVE 0
#define WORKING_SLAVE 1
#define FAILED_SLAVE 2


#define TIME_LIMIT 20	/* definisce in sec. il tempo sotto il quale non conviene suddividere il job */
#define COEFF_VARIANZA 1.0

/*typedef struct fileitem
{
	char *name;
	unsigned long size;
	struct *fileitem;
} FILEITEM;
typedef FILEITEM *filelist;*/

/*typedef struct rectangleitem
{
	int x1,y1,x2,y2;
	struct *rectangleitem;
} RECTANGLEITEM;
typedef RECTANGLEITEM *rectanglelist;
*/


typedef struct filedes
{
	char name[MAX_PATH];
	unsigned long int size;
	unsigned long file_id;
	unsigned long int request_id;
} FILEDES;

typedef struct rectangle
{
	int x1,y1,x2,y2;
	unsigned int request_id;
	unsigned int job_id;
} RECTANGLE;

typedef struct pixel
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
} PIXEL;

typedef struct packet
{
	unsigned long int datagram_id;
	unsigned long int command;
	char data[312];  /* Cos la dimensione del pacchetto dati incapsulato
	                   nel datagramma IP  320 bytes */
} PACKET;


typedef struct request
{
	unsigned long int request_id;
	unsigned long int *file_id;
	int file_no;
	unsigned int size_x, size_y;
	char AA[5];
	int AAon;
	unsigned long int *job_id_arr;
	PIXEL *bitmap;
	int status;
	HWND hWindow;
	int IndexInBox;
} REQUEST;


#define REQ_PENDING 1
#define REQ_WORKING 2

#define JOB_WORKING 1
#define JOB_FAILED 2
#define JOB_PENDING 3
#define JOB_DONE 4

#define SLAVE_UDP_PORT 12345
#define COORD_UDP_PORT 12346
#define SLAVE_TCP_PORT 12347



typedef struct slave
{
	struct in_addr IPaddress;
	int power;
	struct statistics
	{
		float PixelsPerSec;
		int StartTime;
	} stats;
	int status;
	int IndexInBox;
} SLAVE;


typedef struct job
{
	unsigned long int job_id;
	unsigned long int request_id;
	HANDLE ServingThread;
	RECTANGLE rect;
	int status;
	PIXEL *bitmap;
	int STOPTHREAD;
	int secsleft;
	SLAVE sl;
	PACKET LastPacketSent;
	PACKET LastPacketReceived;
	int IndexInBox;
	HANDLE NewPacketEvent;
} JOB;




















#define MATRIX_WIDTH 8
#define STEP 20
#define OH_CONST ((float) 0)  /* sec */
#define OH_NETSPEED ((float) 10000)  /* bytes/sec */


