/****************************************************************************
*                pvengine.c
*----------------------------------------------------------------------------
* 
* Questo programma  stato realizzato nell'ambito del corso di Reti di
* Calcolatori presso la Facolt di Ingegneria dell'Universit di Bologna.
* Si basa sul software POV-Ray copyrighted freeware, e ne costituisce una
* rielaborazione personale
* 
* The terms POV-Ray, POV, and Persistence of Vision Raytracer are trademarks
* of the Persistence of Vision Team.
*---------------------------------------------------------------------------
*
* This program is based on the popular DKB raytracer version 2.12.
* DKBTrace was originally written by David K. Buck.
* DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
*
* Thanks to the makers of PERFORCE (http://www.perforce.com/) for donating the
* copy of their Perforce revision control system that is now used to maintain
* the POVWIN source.
*
* $Id: //depot/windows/pvengine.c#8 $
*
*****************************************************************************/

#define POVWIN_FILE
#define _WIN32_IE COMMONCTRL_VERSION

#include <math.h>
#include <setjmp.h>
#include <string.h>
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>


#include "frame.h"
#include "colour.h"
#include "povray.h"
#include "povproto.h"
#include "optout.h"
#include "userio.h"
#pragma hdrstop

#define DECLARE_TABLES


#ifdef BUGSLAYER
#include "BugslayerUtil.h"
#endif

#include <direct.h>
#include <io.h>
#include <process.h>
#include <assert.h>
#include <sys\stat.h>
#include <commctrl.h>
#include <excpt.h>
#include "optin.h"
#include "pvengine.h"
#include "pvengine.rh"


#include "definitions.h"
#include <winsock.h>

#include <fcntl.h>
#include <sys/types.h>

/*#include <sys\time.h>*/

#ifdef TIMED_BETA
// 893946600 == 30 April 1998
#define EXPIRE_AT       (893946600 + 153 * 86400)
#define DEVELOPMENT
#endif



int                     alert_sound ;
int                     statistics_count = -1 ;
int                     run_count ;
int                     render_anim_count ;
int                     argc ;
char                    command_line [_MAX_PATH * 3] ;
char                    old_command_line [_MAX_PATH * 3] ;
char                    extra_commands [_MAX_PATH * 3] ;
char                    *argv [MAX_ARGV] ;
char                    source_file_name [_MAX_PATH] ;
char                    ourPath [_MAX_PATH] ;
char                    lastRenderName [_MAX_PATH] ;
char                    lastBitmapName [_MAX_PATH] ;
char                    lastRenderPath [_MAX_PATH] ;
char                    lastBitmapPath [_MAX_PATH] ;
char                    lastQueuePath [_MAX_PATH] ;
char                    lastSecondaryIniFilePath [_MAX_PATH] ;
char                    DefaultRenderIniFileName [_MAX_PATH] ;
char                    SecondaryRenderIniFileName [_MAX_PATH] ;
char                    SecondaryRenderIniFileSection [64] ;
char                    background_file [_MAX_PATH] ;
char                    HomePath [_MAX_PATH] ;
char                    EngineIniFileName [_MAX_PATH] ;
char                    RerunIniPath [_MAX_PATH] ;
char                    CurrentRerunFileName [_MAX_PATH] ;
char                    ToolIniFileName [_MAX_PATH] ;
char                    tool_commands [MAX_TOOLCMD] [MAX_TOOLCMDTEXT] ;
char                    tool_help [MAX_TOOLCMD] [MAX_TOOLHELPTEXT] ;
char                    requested_render_file [_MAX_PATH] ;
char                    ErrorMessage [768] ;
char                    ErrorFilename [_MAX_PATH] ;
char                    RegionStr [128] ;
char                    TempRegionStr [128] ;
char                    render_percentage [128] ;
char                    last_render_percentage [128] ;
unsigned                class_registered = 0 ;
unsigned                currentX = 0 ;
unsigned                currentY = 0 ;
unsigned                percentage_complete = 0 ;
unsigned                screen_width ;
unsigned                screen_height ;
unsigned                screen_depth ;
unsigned                background_width ;
unsigned                background_height ;
unsigned                povray_return_code ;
unsigned                loadRerun ;
unsigned                continueRerun ;
unsigned                seconds = 0 ;
unsigned                pixels = 0 ;

unsigned                GUI_priority = CM_GUIPRIORITY_NORMAL ;
unsigned                render_priority = CM_RENDERPRIORITY_NORMAL ;
unsigned                on_completion = CM_COMPLETION_BEEP ;
unsigned                window_count = 0 ;
unsigned                ErrorLine ;
unsigned                ErrorCol ;



BOOL                    quit ;
BOOL                    rendering ;
BOOL                    stop_rendering ;
BOOL                    alert_on_completion ;
BOOL                    save_settings ;
BOOL                    IsWin32 ;
BOOL                    running_demo ;
BOOL                    fast_scroll ;
BOOL                    no_shellout_wait ;
BOOL                    debugging ;
BOOL                    no_palette_warn ;
BOOL                    render_lock_up ;

BOOL                    demo_mode ;
BOOL                    ignore_auto_ini ;

BOOL                    exit_after_render ;
BOOL                    system_noactive ;
BOOL                    terminating ;
BOOL                    need_output_filename ;

BOOL                    run_renderer ;

BOOL                    use_editors = FALSE ;

BOOL                    drop_to_editor ;
BOOL                    restore_command_line ;
BOOL                    render_requested ;
BOOL                    render_auto_close ;
BOOL                    rendersleep ;
BOOL                    noexec ;

BOOL                    NoRestore ;

FILE                    *debugFile ;
HICON                   ourIcon = NULL;

time_t                  render_start_time ;
time_t                  render_finish_time ;
time_t                  render_total_time ;
time_t                  render_pause_time ;
HANDLE                  hRenderThread ;
HANDLE                  hMainThread ;
jmp_buf                 jump_buffer ;


HPALETTE                hPalApp ;
HPALETTE                hPalBitmap ;
COLORREF                background_colour ;
COLORREF                text_colour ;

HINSTANCE               hInstance ;

CRITICAL_SECTION        critical_section ;

char                    queued_files [MAX_QUEUE] [_MAX_PATH] ;

unsigned                queued_file_count = 0 ;
unsigned                auto_render = TRUE ;


int                     renderwin_xoffset ;
int                     renderwin_yoffset ;
int                     renderwin_left = CW_USEDEFAULT ;
int                     renderwin_top = CW_USEDEFAULT ;

unsigned                renderwin_max_width ;
unsigned                renderwin_max_height ;
unsigned                renderwin_8bits ;
unsigned                renderwin_flags = 0 ;
BOOL                    renderwin_active ;
BOOL                    renderwin_destroyed ;
HWND                    render_window;

int                     render_bitmap_depth = -1 ;
long                    render_bitmap_bpl ;
unsigned                render_width ;
unsigned                render_height ;
uchar                   *render_bitmap_surface ;
BitmapInfo              render_bitmap ;
BitmapInfo              bitmap_template ;

extern Opts             opts ;



/* ------------------------------------------------------------------------------- */

#define Wait(object) WaitForSingleObject(object,INFINITE)
#define Signal(object) ReleaseMutex(object)

#define DIR_SIZE 128
#define CMDLINE_SIZE 128

unsigned              width ;
unsigned              height ;

static int            lastx = 0, lasty = 0 ;

HANDLE CreateRenderWindowSignal, RenderWindowCreated, ExpectedPacketArrived, LastPacketsMutex,
	   MasterAlive_Event, MasterFound, ConsoleMutex, receiving_thread_udp, h[3];

HWND New_render_window;

int	potenza_di_calcolo= 1, coord_found = 0, UltimaLineaEseguita, ErroreTrasferimentoBitmap,
    Power, /*richiesta = 0,*/ NetworkSend = 0, SlaveMustContinue = 1, MustQuit = 0, RenderingFermato = 0,
	RenderingInEsecuzione;
unsigned int LastReceivedPacket_id = 0;


DWORD MainThreadId;

SOCKET udp_sock, tcp_sock, ns;
struct sockaddr_in master_address;


PACKET LastSentPacket, LastReceivedPacket;

uchar *My_render_bitmap_surface;

REQUEST RequestArray[MAX_REQUEST/*128*/];
int fullReqArr[MAX_REQUEST/*128*/];

JOB Job;

char FileTable[MAX_FILES][MAX_PATH];
int FileSize[MAX_FILES];
int FileDescriptor[MAX_FILES];
int ProcessedRequestArray[MAX_REQUEST];

#define MAINBUFFERSIZE 1024
char MainBuffer[MAINBUFFERSIZE];

char MainWorkDir[DIR_SIZE];
char localhostname[255];


	


// Originale
#ifdef BUGSLAYER
LONG __stdcall ExceptCallBack (EXCEPTION_POINTERS *pExPtrs)
{
  const char  *szBuff ;
  FILE        *f ;

  if ((f = fopen ("c:\\pvexcept.log", "wt")) == NULL)
    return (EXCEPTION_CONTINUE_SEARCH) ;
  
  fprintf (f, "%s\n" , GetFaultReason (pExPtrs)) ;
  fprintf (f, "%s\n" , GetRegisterString (pExPtrs)) ;
  szBuff = GetFirstStackTraceString (GSTSO_PARAMS | GSTSO_MODULE | GSTSO_SYMBOL | GSTSO_SRCLINE, pExPtrs) ;
  do
  {
    fprintf (f, "%s\n", szBuff) ;
    fflush (f) ;
    szBuff = GetNextStackTraceString (GSTSO_PARAMS | GSTSO_MODULE | GSTSO_SYMBOL | GSTSO_SRCLINE, pExPtrs) ;
  }
  while (szBuff != NULL) ;
  fclose (f) ;
  MessageBox (NULL, "POV-Ray has encountered an internal error and will now exit.\n\n"
                    "Please consult c:\\pvexcept.log", "Exception", MB_OK | MB_ICONSTOP) ;
  exit (-1) ;
  return (EXCEPTION_CONTINUE_SEARCH) ;
}
#endif

#if 0
LONG PovUnhandledExceptionFilter (EXCEPTION_POINTERS *lpexpExceptionInfo)
{
//int         i ;
  char        str [256] ;
//DWORD       ebp ;
  PCONTEXT    c ;

  c = lpexpExceptionInfo->ContextRecord ;
  sprintf (str, "An exception was generated at address %08lX\n\nPOV-Ray will now exit", c->Eip) ;
  MessageBox (NULL, str, "Error", MB_ICONSTOP | MB_SYSTEMMODAL) ;
//if (MessageBox (NULL, "POV - Unhandled exception. Unwind stack ?", "Error", MB_ICONSTOP | MB_YESNO | MB_SYSTEMMODAL) == IDYES)
//{
//  c = lpexpExceptionInfo->ContextRecord ;
//  sprintf (str, "An exception was generated at address %08lX", c->Eip) ;
//  MessageBox (NULL, str, "Oops", MB_ICONINFORMATION | MB_SYSTEMMODAL) ;
//  ebp = c->Ebp ;
//  // add in stack walking code here.
//}
  ExitProcess (1) ;
  return (EXCEPTION_CONTINUE_SEARCH) ; // make compiler happy
}
#endif

// Originale
void debug (char *format, ...)
{
  char                  str [2048] ;
  va_list               arg_ptr ;
  FILE                  *f ;

  if ((f = fopen ("debug.txt", "a+t")) != NULL)
  {
    va_start (arg_ptr, format) ;
    vsprintf (str, format, arg_ptr) ;
    va_end (arg_ptr) ;
    fprintf (f, "%s", str) ;
    fclose (f) ;
  }
}


// Originale
#ifdef __WATCOMC__                        /* Watcom C/C++ C32 */
void Fix_Watcom_Bug(char *s)
{
  char *p=s;

  while(*p != '\0')
  {
    if (*p==' ')
    {
      *p='0';
    }
    p++;
  }
}
#endif






// Modificata
DWORD WINAPI render_thread (LPDWORD lpdwParam)
{
  WIN_Povray (argc, argv) ;

  /*DestroyWindow(New_render_window);*/
  //SendMessage(New_render_window, WM_DESTROY, 0, 0);
  PostThreadMessage(MainThreadId, WM_USER, 0, 0);
  /*SendMessage(New_render_window, WM_QUIT, 0, 0);*/
  
  run_renderer = FALSE ;
  ExitThread(UltimaLineaEseguita);
  return (0) ;
}


// Originale
void set_render_priority (unsigned priority)
{
  switch (priority)
  {
    case CM_RENDERPRIORITY_LOWEST :
         SetThreadPriority (hRenderThread, THREAD_PRIORITY_LOWEST) ;
         break ;

    case CM_RENDERPRIORITY_LOW :
         SetThreadPriority (hRenderThread, THREAD_PRIORITY_BELOW_NORMAL) ;
         break ;

    case CM_RENDERPRIORITY_NORMAL :
         SetThreadPriority (hRenderThread, THREAD_PRIORITY_NORMAL) ;
         break ;

    case CM_RENDERPRIORITY_HIGH :
         SetThreadPriority (hRenderThread, THREAD_PRIORITY_ABOVE_NORMAL) ;
         break ;

    case CM_RENDERPRIORITY_HIGHEST :
         SetThreadPriority (hRenderThread, THREAD_PRIORITY_HIGHEST) ;
         break ;
  }
}

// Originale
void set_GUI_priority (unsigned priority)
{
  switch (GUI_priority)
  {
    case CM_GUIPRIORITY_LOWEST :
         SetThreadPriority (hMainThread, THREAD_PRIORITY_LOWEST) ;
         break ;

    case CM_GUIPRIORITY_LOW :
         SetThreadPriority (hMainThread, THREAD_PRIORITY_BELOW_NORMAL) ;
         break ;

    case CM_GUIPRIORITY_NORMAL :
         SetThreadPriority (hMainThread, THREAD_PRIORITY_NORMAL) ;
         break ;

    case CM_GUIPRIORITY_HIGH :
         SetThreadPriority (hMainThread, THREAD_PRIORITY_ABOVE_NORMAL) ;
         break ;

    case CM_GUIPRIORITY_HIGHEST :
         SetThreadPriority (hMainThread, THREAD_PRIORITY_HIGHEST) ;
         break ;
  }
}







// Modificata
void display_cleanup (void)
{
  /*if (New_render_window != NULL)
  {
    DestroyWindow (New_render_window) ;
    New_render_window = NULL ;
    renderwin_destroyed = FALSE ;
  }*/
  if (render_bitmap_surface != NULL)
  {
    free (render_bitmap_surface) ;
    render_bitmap_surface = NULL ;

	// Mio codice
	free (My_render_bitmap_surface) ;
    My_render_bitmap_surface = NULL ;

  }

}


// Originale
void validatePath (char *s)
{
  if (s [1] == ':' && strlen (s) < 4)
    return ;
  s += strlen (s) - 1 ;
  if (*s == '\\')
    *s = '\0' ;
}


// Originale
int joinPath (char *out, char *path, char *name)
{
  strcpy (out, path) ;
  if (path [strlen (path) - 1] != '\\')
    strcat (out, "\\") ;
  strcat (out, name) ;
  return (strlen (out)) ;
}


// Originale
void setRunOnce (void)
{
  char        str [_MAX_PATH] ;
  HKEY        key ;
  DWORD       result ;

  if (RegCreateKeyEx (HKEY_CURRENT_USER,
                      "Software\\Microsoft\\Windows\\CurrentVersion\\RunOnce",
                      0,
                      "",
                      REG_OPTION_NON_VOLATILE,
                      KEY_WRITE,
                      NULL,
                      &key,
                      &result) == ERROR_SUCCESS)
  {
    GetModuleFileName (hInstance, str, sizeof (str)) ;
    RegSetValueEx (key, "POV-Ray for Windows v3.1", 0, REG_SZ, str, strlen (str) + 1) ;
    RegCloseKey (key) ;
  }
}

// Originale
void getHome (void)
{
  HKEY        key ;
  DWORD       len = sizeof (HomePath) ;

  if (debugFile)
    fprintf (debugFile, "querying registry\n") ;
  HomePath [0] = '\0' ;
  
  if (RegOpenKeyEx (HKEY_LOCAL_MACHINE,
                      "Software\\POV-Ray\\v3.1\\Windows",
                      0,
                      KEY_READ,
                      &key) == ERROR_SUCCESS)
    {
      RegQueryValueEx (key, "Home", 0, NULL, HomePath, &len) ;
      RegCloseKey (key) ;
      if (debugFile)
        fprintf (debugFile, "Win32 getHome () succeeded, HomePath is '%s'\n", HomePath) ;
    }
  
}

// Originale
void setCommandLine (char *s)
{
  HKEY        key ;
  DWORD       result ;

  if (IsWin32)
  {
    if (RegCreateKeyEx (HKEY_LOCAL_MACHINE,
                        "Software\\POV-Ray\\v3.1\\Windows",
                        0,
                        "",
                        REG_OPTION_NON_VOLATILE,
                        KEY_WRITE,
                        NULL,
                        &key,
                        &result) == ERROR_SUCCESS)
    {
      RegSetValueEx (key, "Command Line", 0, REG_SZ, s, strlen (s) + 1) ;
      RegCloseKey (key) ;
    }
  }
  else
  {
    if (RegCreateKey (HKEY_CLASSES_ROOT, "POV-Ray\\CommandLine", &key) == ERROR_SUCCESS)
    {
      RegSetValue (key, NULL, REG_SZ, s, strlen (s)) ;
      RegCloseKey (key) ;
    }
  }
}

// Originale
char *getCommandLine (void)
{
  HKEY        key ;
  static char str [2048] ;
  DWORD       len = sizeof (str) ;

  str [0] = '\0' ;
  if (IsWin32)
  {
    if (RegOpenKeyEx (HKEY_LOCAL_MACHINE,
                      "Software\\POV-Ray\\v3.1\\Windows",
                      0,
                      KEY_READ,
                      &key) == ERROR_SUCCESS)
    {
      RegQueryValueEx (key, "Command Line", 0, NULL, str, &len) ;
      RegCloseKey (key) ;
    }
  }
  else
  {
    if (RegOpenKey (HKEY_CLASSES_ROOT, "POV-Ray\\CommandLine", &key) == ERROR_SUCCESS)
    {
      RegQueryValue (key, NULL, str, (LONG *) &len) ;
      RegCloseKey (key) ;
    }
  }
  return (str) ;
}

// Originale
int parse_commandline (char *s)
{
  char        *prevWord = NULL ;
  BOOL        inQuote = FALSE ;
  BOOL        noStrip = FALSE ;
  static char str [_MAX_PATH * 3] ;
  static char filename [_MAX_PATH] ;

  argc = 0 ;
  GetModuleFileName (hInstance, filename, sizeof (filename) - 1) ;
  argv [argc++] = filename ;
  s = strncpy (str, s, sizeof (str) - 1) ;
  while (*s)
  {
    switch (*s)
    {
      case '"' :
           if (prevWord != NULL)
           {
             if (inQuote)
             {
               if (!noStrip)
                 *s = '\0' ;
               argv [argc++] = prevWord ;
               prevWord = NULL ;
             }
             else
               noStrip = TRUE ;
           }
           inQuote = !inQuote ;
           break ;

      case ' ' :
      case '\t' :
           if (!inQuote)
           {
             if (prevWord != NULL)
             {
               *s = '\0' ;
               argv [argc++] = prevWord ;
               prevWord = NULL ;
               noStrip = FALSE ;
             }
           }
           break ;

      default :
           if (prevWord == NULL)
             prevWord = s ;
           break ;
    }
    if (argc >= MAX_ARGV - 1)
      break ;
    s++ ;
  }
  if ((prevWord != NULL || (inQuote && prevWord != NULL)) && argc < MAX_ARGV - 1)
  {
    *s = '\0' ;
    argv [argc++] = prevWord ;
  }
  argv [argc] = NULL ;
  return (argc) ;
}




LRESULT CALLBACK Render_Window_Procedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	int oldMode ;

  	switch (message)
	{
	case WM_CREATE :
		return 0;

	case WM_USER :
		return 0;

	case WM_SIZE :
		return 0;

	case WM_PAINT :
        /*if ((hdc = GetDC (New_render_window)) == NULL)
			return 0;*/
		hdc = BeginPaint(hwnd,&ps);
        oldMode = SetStretchBltMode (hdc, STRETCH_DELETESCANS) ;
        if (hPalApp)
		{
          SelectPalette (hdc, hPalApp, FALSE) ;
          RealizePalette (hdc) ;
		}
    
        // Aggiungo la linea corrente
		/*StretchDIBits (hdc, -renderwin_xoffset, lasty - renderwin_yoffset, render_width, -1, 0, render_bitmap.header.biHeight - 1 - lasty,
                         render_bitmap.header.biWidth, 1, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap, DIB_RGB_COLORS, SRCCOPY) ;*/
		
		// Ridisegno tutto
	    /*StretchDIBits (hdc, -renderwin_xoffset, -renderwin_yoffset, render_width,	render_height, 0, 0, render_bitmap.header.biWidth,
						 render_bitmap.header.biHeight, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap,  DIB_RGB_COLORS, SRCCOPY );*/
		
		

		//bitmap rovesciata lungo x	
		/*StretchDIBits (hdc, 0, 0, render_width, lasty, 0, render_bitmap.header.biHeight - 1, render_bitmap.header.biWidth,
						 -lasty, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap, DIB_RGB_COLORS, SRCCOPY );*/

		/*StretchDIBits (hdc, 0, lasty, render_width, -lasty, 0, render_bitmap.header.biHeight - 1, render_bitmap.header.biWidth,
						 -lasty, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap, DIB_RGB_COLORS, SRCCOPY );
		*/
	
	
		if (render_bitmap_surface)
		// Disegno dall'inizio fino a dove sono arrivato
		StretchDIBits (hdc, 0, 0,	render_width, lasty,		0, render_bitmap.header.biHeight - 1 - lasty,
					   render_bitmap.header.biWidth, lasty,
					   render_bitmap_surface, (LPBITMAPINFO) &render_bitmap, DIB_RGB_COLORS, SRCCOPY );
	
		
		/*StretchDIBits (hdc, 0, 0, render_width, lasty, 0, render_bitmap.header.biHeight - 1 ,
						 render_bitmap.header.biWidth, -lasty, render_bitmap_surface, (LPBITMAPINFO) &render_bitmap, DIB_RGB_COLORS, SRCCOPY );*/
	
        
        sprintf (render_percentage, "Rendering... [%d%%]", (render_bitmap_surface ? ( (currentY - opts.First_Line + 1) * 100 / (opts.Last_Line - opts.First_Line + 1) ) : 0)) ;
		SetWindowText(New_render_window, render_percentage);
      
        SetStretchBltMode (hdc, oldMode) ;
/*      ReleaseDC (New_render_window, hdc) ;
		ValidateRect(New_render_window, NULL);*/
        EndPaint (hwnd, &ps) ;

		return 0;

	case WM_DESTROY :
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
	
}






// Modificata
void start_rendering (BOOL is_auto_render, BOOL ignore_source_file)
{
  MSG         msg ;
  DWORD       threadId = 0 ;
  DWORD       threadParam = 0 ;

  int statouscita = 0;

  HINSTANCE hI;

  int a;

  Max_Trace_Level = 5 ; // re-initialise max_trace_level (bug report WIN31-002).
  extra_commands [0] = '\0' ;
  ErrorMessage [0] = '\0' ;
  ErrorFilename [0] = '\0' ;
  renderwin_destroyed = FALSE ;
  rendersleep = FALSE ;
/*  display_cleanup () ;*/
  render_anim_count = 0 ;

  statistics_count = 0 ;
  stop_rendering = FALSE ;
  percentage_complete = 0 ;
  WIN_Pre_Pixel (-1, -1, 0) ;

	CreateRenderWindowSignal = CreateEvent(NULL, TRUE, FALSE, NULL);
	RenderWindowCreated = CreateEvent(NULL, TRUE, FALSE, NULL);

  MainThreadId = GetCurrentThreadId();
  UltimaLineaEseguita = 0;

  hRenderThread = CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) render_thread, &threadParam, 0, &threadId) ;

  if (hRenderThread != NULL)
  {
    run_renderer = TRUE ;
	hI = GetModuleHandle(NULL);
    /*set_render_priority (render_priority) ;
    set_GUI_priority (GUI_priority) ;*/
    
	WaitForSingleObject(CreateRenderWindowSignal,INFINITE);
	
	New_render_window = CreateWindow( "render_window", "Rendering...",
									/*WS_OVERLAPPEDWINDOW,*/
									WS_BORDER | WS_CAPTION | WS_SYSMENU,
									CW_USEDEFAULT, CW_USEDEFAULT,
									width, height,
									NULL, NULL, hI, NULL ) ;
	if (!New_render_window)
		a = GetLastError();

	
	
	ShowWindow(New_render_window, SW_SHOW);
	UpdateWindow(New_render_window);

	SetEvent(RenderWindowCreated);

	
	while ( /*(run_renderer) &&*/ /*(PeekMessage (&msg, NULL, 0, 0, PM_REMOVE) == TRUE)*/
		      ((a =GetMessage( &msg, NULL, 0, 0)) > 0) )
      {
		TranslateMessage (&msg) ;
        DispatchMessage (&msg) ;
		if (msg.message==WM_USER)
			DestroyWindow(New_render_window);
      }
      /*Sleep (500) ;*/
    
    WaitForSingleObject(hRenderThread,INFINITE);
	statouscita = 0;
	GetExitCodeThread(hRenderThread, &statouscita);
	CloseHandle (hRenderThread) ;
    hRenderThread = NULL ;
	/*a = DestroyWindow(New_render_window);
	while (    (a =GetMessage( &msg, NULL, 0, 0)) > 0) 
      {
		  TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
      }
    */
	//New_render_window = 0;
    //set_GUI_priority (CM_GUIPRIORITY_NORMAL) ;

	//while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) == TRUE) ;
	//a = DestroyWindow(New_render_window);
	//New_render_window = 0;
	// flush della coda dei messaggi della finestra distrutta
  }
  else
    printf("Error: Cannot create thread for render process!\n") ;
  /*rendersleep = FALSE ;*/
  
  printf("Povray return code : %d\n", povray_return_code);

  
}


// Originale
HPALETTE create_palette (RGBQUAD *rgb, int entries)
{
  int         i ;
  HDC         hdc ;
  LogPal      Palette = { 0x300, 256 } ;

  if (screen_depth == 8 || render_bitmap_depth == 8)
  {
    if (rgb)
    {
      Palette.entries = entries ;
      for (i = 0 ; i < entries ; i++, rgb++)
      {
        Palette.pe [i].peRed = rgb->rgbRed ;
        Palette.pe [i].peGreen = rgb->rgbGreen ;
        Palette.pe [i].peBlue = rgb->rgbBlue ;
        Palette.pe [i].peFlags = PC_NOCOLLAPSE ;
      }
    }
    else
    {
      // Copy the halftone palette into the DIB palette entries, and read the
      // current system palette entries to ensure we have an identity palette mapping.
      hdc = GetDC (NULL) ;
      memcpy (bitmap_template.colors, halftonePal, sizeof (halftonePal)) ;
      GetSystemPaletteEntries (hdc, 0, 256, Palette.pe) ;
      for (i = 0 ; i < 10 ; i++)
      {
        bitmap_template.colors [i].rgbRed = Palette.pe [i].peRed ;
        bitmap_template.colors [i].rgbGreen = Palette.pe [i].peGreen ;
        bitmap_template.colors [i].rgbBlue = Palette.pe [i].peBlue ;
        Palette.pe [i].peFlags = 0 ;
        bitmap_template.colors [i + 246].rgbRed = Palette.pe [i + 246].peRed ;
        bitmap_template.colors [i + 246].rgbGreen = Palette.pe [i + 246].peGreen ;
        bitmap_template.colors [i + 246].rgbBlue = Palette.pe [i + 246].peBlue ;
        Palette.pe [i + 246].peFlags = 0 ;
      }
      while (i < 246)
      {
        Palette.pe [i].peRed = bitmap_template.colors [i].rgbRed ;
        Palette.pe [i].peGreen = bitmap_template.colors [i].rgbGreen ;
        Palette.pe [i].peBlue = bitmap_template.colors [i].rgbBlue ;
        Palette.pe [i++].peFlags = PC_NOCOLLAPSE ;
      }
      ReleaseDC (NULL, hdc) ;
    }
    return (CreatePalette ((LOGPALETTE *) &Palette)) ;
  }
  return (NULL) ;
}

// Originale
BOOL create_render_bitmap (int width, int height)
{
  render_bitmap = bitmap_template ;
  render_bitmap.header.biSize = sizeof (BITMAPINFOHEADER) ;
  render_bitmap.header.biWidth = width ;
  render_bitmap.header.biHeight = height ;
  render_bitmap.header.biPlanes = 1 ;
  render_bitmap.header.biBitCount = (WORD) render_bitmap_depth ;
  render_bitmap.header.biCompression = BI_RGB ;
  if (render_bitmap_depth == 8)
  {
    // round out the bits per line to a multiple of four
    render_bitmap_bpl = (width + 3) & ~3 ;
    render_bitmap.header.biClrUsed = 256 ;
  }
  else
  {
    render_bitmap_bpl = (width * 3 + 3) & ~3 ;
    render_bitmap.header.biClrUsed = 0 ;
  }
  render_bitmap.header.biSizeImage = render_bitmap_bpl * height ;
  render_bitmap.header.biClrImportant = 0 ;
  
  // Mio codice
  My_render_bitmap_surface = calloc (1, render_bitmap.header.biSizeImage);
  
  return ((render_bitmap_surface = calloc (1, render_bitmap.header.biSizeImage)) != NULL) ;
}


// Originale
BOOL create_render_window (void)
{
  unsigned              flags ;
  RECT                  rect ;

  /*if (New_render_window)
    DestroyWindow (New_render_window) ;*/
  renderwin_destroyed = FALSE ;
  renderwin_xoffset = renderwin_yoffset = 0 ;
  rect.left = 0 ;
  rect.top = 0 ;
  rect.right = render_width ;
  rect.bottom = render_height ;
  flags = WS_BORDER | WS_CAPTION | WS_SYSMENU | WS_VISIBLE ;


  AdjustWindowRect (&rect, flags, FALSE) ;

  // left and top will probably be negative
  width = renderwin_max_width = rect.right - rect.left ;
  height = renderwin_max_height = rect.bottom - rect.top ;

  if (width > screen_width - 64)
    width = screen_width - 64 ;
  if (height > screen_height - 48)
    height = screen_height - 48 ;

  if (renderwin_left < 0)
    renderwin_left = 0 ;
  if (renderwin_top < 0)
    renderwin_top = 0 ;

  if (renderwin_left + width > screen_width)
    renderwin_left = screen_width - width ;
  if (renderwin_top + height > screen_height)
    renderwin_top = screen_height - height ;

	SetEvent(CreateRenderWindowSignal);

	WaitForSingleObject(RenderWindowCreated,INFINITE);

	CloseHandle(CreateRenderWindowSignal);
	CloseHandle(RenderWindowCreated);
	

  return (TRUE) ;
}


// Originale
int renderwin_init (void)
{
  display_cleanup () ;
  if (create_render_window () == FALSE)
  {
    PovMessageBox ("Failed to create display window", "Initialize Display - Fatal Error") ;
    display_cleanup () ;
    return (1) ;
  }
  if (create_render_bitmap (render_width, render_height) == FALSE)
  {
    PovMessageBox ("Failed to allocate display bitmap", "Initialize Display - Fatal Error") ;
    display_cleanup () ;
    return (1) ;
  }
  return (0) ;
}


// Originale
void WIN_Display_Init (int x, int y)     /*Qui devo far creare la finestra di rendering*/
{
  render_width = x ;
  render_height = y ;

/*  if (SendMessage (main_window, CREATE_RENDERWIN_MESSAGE, 0, 0L))
    Terminate_POV (-1) ;*/

  display_cleanup () ;

  if (create_render_window () == FALSE)
  {
    PovMessageBox ("Failed to create display window", "Initialize Display - Fatal Error") ;
    display_cleanup () ;
    return /*(1)*/ ;
  }

  if (create_render_bitmap (render_width, render_height) == FALSE)
  {
    PovMessageBox ("Failed to allocate display bitmap", "Initialize Display - Fatal Error") ;
    display_cleanup () ;
    return /*(1)*/ ;
  }

  

  
  
  WIN_Display_Plot (-1, -1, 0, 0, 0, 0) ;  
}


// Originale
void WIN_Display_Finished (void)
{
  PovInvalidateRect (New_render_window, NULL, FALSE) ;
}

// Originale
void WIN_Display_Close (void)
{
}

// Modificata
void WIN_Display_Plot (int x, int y, int Red, int Green, int Blue, int Alpha)
{
  uchar                 *p ;
  uchar					*my_p;
  uchar                 dither ;
  int res,w/*,wtot*/;


  if (x == -1 || y == -1)
  {
    lastx = lasty = 0 ;
    return ;
  }
  if (x < 0 || x >= render_width || y < 0 || y >= render_height)
    return ;
  if (render_bitmap_surface == NULL)
    return ;
  percentage_complete = (y - opts.First_Line + 1) * 100 / (opts.Last_Line - opts.First_Line + 1) ;
  if (New_render_window != NULL && (x < lastx || y != lasty))
  {
    // DEVO INVIARE ALLA FINESTRA UN MESSAGGIO DI RIDISEGNO
    // Blt the completed scanline to the display
	  UltimaLineaEseguita = y - 1;
	  InvalidateRect(New_render_window,NULL,FALSE);
	  UpdateWindow(New_render_window);

	// Se sono qui  appena cominciata una nuova linea 
  }
  lastx = x ;
  lasty = y ;
  if (render_bitmap_depth == 8)
  {
    p = render_bitmap_surface + (render_bitmap.header.biHeight - 1 - y) * render_bitmap_bpl + x ;
    dither = dither8x8 [((x & 7) << 3) | (y & 7)] ;
    *p = 20 + div51 [Red] + (mod51 [Red] > dither) +
              mul6 [div51 [Green] + (mod51 [Green] > dither)] +
              mul36 [div51 [Blue] + (mod51 [Blue] > dither)] ;
  }
  else
  {
    p = render_bitmap_surface + (render_bitmap.header.biHeight - 1 - y) * render_bitmap_bpl + x * 3 ;
    p [0] = Blue ;
    p [1] = Green ;
    p [2] = Red ;

/*	if (x >= opts.First_Column)
		if (NetworkSend) res = send(ns, p, 3*sizeof(uchar), 0);*/

	if (NetworkSend)
	{
	    if ((x>=opts.First_Column) && (y>=opts.First_Line))
		{
			w = (opts.Last_Column - opts.First_Column)*3;
			//wtot = render_width * 3;

			my_p = My_render_bitmap_surface + y * render_bitmap_bpl + x*3;
			my_p[0] = Blue;
			my_p[1] = Green;
			my_p[2] = Red;
		
			
	  		if ((y>opts.First_Line) && (x == opts.First_Column))
			{
				res = send(ns, My_render_bitmap_surface + (y-1)* render_bitmap_bpl + opts.First_Column*3 , w, 0);
				if ((res==SOCKET_ERROR) || (res==0))  {	ErroreTrasferimentoBitmap = 1;	Stop_Flag = TRUE;	}
			}
			else
				if ((y == (opts.Last_Line-1)) && (x == (opts.Last_Column-1)))
				{
					res = send(ns, My_render_bitmap_surface + y*render_bitmap_bpl +opts.First_Column*3 , w, 0);  
					if ((res==SOCKET_ERROR) || (res==0))  {	ErroreTrasferimentoBitmap = 1;	Stop_Flag = TRUE;	}
				}
		}
	}

		
		
	
  }
}


// Originale
void WIN_Pre_Pixel (int x, int y, COLOUR colour)
{
  char                  str1 [_MAX_PATH] ;
  static int            lastY = -1 ;
  static int            last_seconds = -1 ;

  if (need_output_filename)
  {
    WritePrivateProfileString ("LastRender", "HistogramFile", get_full_name (opts.Histogram_File_Name), EngineIniFileName) ;
    if (opts.Output_Path [0] != '\0')
    {
      sprintf (str1, "%s%s", opts.Output_Path, opts.Output_File_Name) ;
      WritePrivateProfileString ("LastRender", "OutputFile", str1, EngineIniFileName) ;
    }
    else
      WritePrivateProfileString ("LastRender", "OutputFile", get_full_name (opts.Output_File_Name), EngineIniFileName) ;
    need_output_filename = 0 ;
  }

  currentX = x ;

  /* Short circuit unless scanline has changed */
 if (y == -1)
  {
    last_seconds = lastY = -1 ;
    return ;
  }
  if (y == lastY)
    return ;

  lastY = currentY = y ;

  if (seconds != last_seconds)
  {
    last_seconds = seconds ;
    percentage_complete = (y - opts.First_Line + 1) * 100 / (opts.Last_Line - opts.First_Line + 1) ;
  }
}

// Originale
void WIN_Post_Pixel (int x, int y, COLOUR colour)
{
  pixels++ ;
  Sleep(0);
}

// Modificata
void WIN_Banner (char *s)
{
  printf("%s\n",s);
}

// Modificata
void WIN_Warning (char *s)
{
  /*buffer_message (mWarning, s) ;*/
  printf("Warning: %s\n",s);
}

// Modificata
void WIN_Render_Info (char *s)
{
  printf("Render Info: %s\n", s);
}

// Modificata
void WIN_Status_Info (char *s)
{
  // as a general rule, we don't display any message that starts with a space
  // these are usually continuations of previous messages
  if (strlen (s) > 3 && *s != ' ')
	printf("Status Info: %s\n",s);
}

// Modificata
void WIN_Debug_Info (char *s)
{
  /*buffer_message (mDebug, s) ;*/
  printf("Debug Info: %s\n",s);
}

// Originale
void WIN_WhereError (char *FileName, int Line, char *SrcLine, int Index, char *Token)
{
  if (ErrorFilename [0] || Token == NULL)
    return ;
  strcpy (ErrorFilename, FileName) ;
  ErrorLine = Line ;
  ErrorCol = Index - strlen (Token) + 1 ;
}


// Modificata
void WIN_Fatal (char *s)
{
  strncat (ErrorMessage, s, sizeof (ErrorMessage) - 1) ;
  printf("Fatal: %s\n",s);
}

// Modificata
void WIN_Statistics (char *s)
{
  printf("Statistics: %s\n",s);
}

// Originale
void WIN_Startup (void)
{
}

// Originale
void WIN_Finish (int n)
{
  povray_return_code = n ;
  longjmp (jump_buffer, 1) ;
}

// Originale
// priority == 0 when called from a higher level (e.g. in Trace_Pixel()).
void WIN_Cooperate (int priority)
{
  while (rendersleep && !(quit || stop_rendering))
  {
    if (IsWin32)
      Sleep (100) ;
  }

  if (terminating == FALSE && (quit || stop_rendering))
  {
    terminating = TRUE ;
    // warning - this function call doesn't return !
    Terminate_POV (-1) ;
  }
}

// Modificata
int WIN_Povray (int argc, char **argv)
{
  int         rval ;

  pre_init_flag = 0 ;
  pre_init_povray () ;
  povray_return_code = -1 ;
  if ((rval = setjmp (jump_buffer)) != 0)
  {
    if (povray_return_code == 0)
    {
      PutPrivateProfileInt ("Statistics", "FinishRender", time (NULL), CurrentRerunFileName) ;
      printf("Returned from renderer\n");
      rotate_rerun_entries () ;
      printf("POV-Ray finished\n");
    }
    else
    {
      printf("\n");
      printf("Returned from renderer (non-zero return value)\n");
      close_all () ;
      mem_release_all (FALSE) ;
      pre_init_flag = 0 ;

	  SetEvent(CreateRenderWindowSignal);
    }
  }
  else
  {
    // setjmp succeeded, so we call POV-Ray. we expect POV to return via a longjmp always.
    rendering = TRUE ;
    terminating = FALSE ;
    render_start_time = time (NULL) ;
    render_total_time = 0 ;
    render_pause_time = 0 ;
    pixels = 0 ;
    alt_main (argc, argv) ;
    assert (FALSE) ;
  }
  HEAPSHRINK
  render_finish_time = time (NULL) ;
  rendering = FALSE ;
  terminating = FALSE ;
  render_total_time = render_finish_time - render_start_time - render_pause_time ;
  if (render_total_time > 0)
  {
	  printf ("%u PPS\n", pixels / render_total_time) ;
  }

  printf("Elapsed time: %s",get_elapsed_time (render_start_time, render_finish_time, render_pause_time));

  running_demo = FALSE ;
  printf("\n");
  fcloseall () ;
  if (debugFile)
    debugFile = fopen ("c:\\povray.dbg", "at") ;
  return (rval) ;
}

// Originale
int WIN_System (char *s)
{
  char                  *message = "POV-Ray is running an external application. Do you want to halt this application ?\n\n"
                                   "If you specify YES this application will be terminated, but note that this could lead\nto an incomplete clean-up. "
                                   "The use of this facility is not recommended.\n\n"
                                   "If you specify NO the application will remain running\n\nIf you specify CANCEL POV-Ray will continue rendering." ;
  MSG                   msg ;
  DWORD                 code = WAIT_TIMEOUT ;
  STARTUPINFO           startupInfo ;
  PROCESS_INFORMATION   procInfo ;

  if (noexec)
  {
    message_printf ("External exec request '%s' made but NOEXEC set\n", s) ;
    printf("Security warning: External exec request made but NOEXEC set\n\nPOV-Ray will now exit\n") ;
    quit = TRUE ;
    return (-1) ;
  }

  printf("POV-Ray is creating another process\n") ;
  message_printf ("  %s\n", s) ;

  startupInfo.cb               = sizeof (STARTUPINFO) ;
  startupInfo.lpReserved       = 0 ;
  startupInfo.lpDesktop        = NULL ;
  startupInfo.lpTitle          = NULL ;
  startupInfo.dwX              = 0 ;
  startupInfo.dwY              = 0 ;
  startupInfo.dwXSize          = 0 ;
  startupInfo.dwYSize          = 0 ;
  startupInfo.dwXCountChars    = 0 ;
  startupInfo.dwYCountChars    = 0 ;
  startupInfo.dwFillAttribute  = 0 ;
  startupInfo.dwFlags          = system_noactive ? STARTF_USESHOWWINDOW : 0 ;
  startupInfo.wShowWindow      = SW_SHOWMINNOACTIVE ;
  startupInfo.cbReserved2      = 0 ;
  startupInfo.lpReserved2      = 0 ;

  if (CreateProcess (NULL, s, NULL, NULL, FALSE, 0, NULL, NULL, &startupInfo, &procInfo) == FALSE)
  {
    printf("Could not create process\n") ;
    return (GetLastError ()) ;
  }

  if (no_shellout_wait == 0)
  {
    // now wait for the process to exit
    while (code == WAIT_TIMEOUT && no_shellout_wait == 0)
    {
      if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
      {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
	  }
      code = WaitForSingleObject (procInfo.hProcess, 25) ;
      if (quit || stop_rendering)
      {
        GetExitCodeProcess (procInfo.hProcess, &code) ;
        if (code == STILL_ACTIVE)
        {
			TerminateProcess (procInfo.hProcess, 1) ;
		}
        CloseHandle (procInfo.hProcess) ;
        CloseHandle (procInfo.hThread) ;
        printf ("\n") ;
        Terminate_POV (-1) ;
      }
    }
    GetExitCodeProcess (procInfo.hProcess, &code) ;
  }
  else
    code = 0 ;

  // clean up
  CloseHandle (procInfo.hProcess) ;
  CloseHandle (procInfo.hThread) ;

  // code now has the application's return code
  return (code) ;
}


// Originale
void WIN_SaveRerun (void)
{
  write_rerun_information () ;
  PutPrivateProfileInt ("Statistics", "StartRender", time (NULL), CurrentRerunFileName) ;
}


// Originale
void WIN_ParseINI (void)
{
  if (!ignore_auto_ini)
  {
    parse_ini_file (DefaultRenderIniFileName) ;
    if (getenv("POVINI") == NULL)
      parse_ini_file ("povray.ini");
  }
}

// Originale
void WIN_Write_Line (COLOUR *line, int y)
{

}

// Originale
void WIN_Assign_Pixel (int x, int y, COLOUR colour)
{
}


// Modificata
void PovMessageBox (char *message, char *title)
{
	printf("%s: %s\n",title, message);
}

// Originale
void detect_graphics_config (void)
{
  HDC   hdc ;

  hdc = GetDC (NULL) ;
  screen_depth = GetDeviceCaps (hdc, BITSPIXEL) ;
  render_bitmap_depth = (GetDeviceCaps (hdc, BITSPIXEL) > 8 && renderwin_8bits == 0) ? 24 : 8 ;
  screen_width = GetDeviceCaps (hdc, HORZRES) ;
  screen_height = GetDeviceCaps (hdc, VERTRES) ;
  ReleaseDC (NULL, hdc) ;
}

// Clear the system palette when we start to ensure an identity palette mapping
void clear_system_palette (void)
{
  int         Counter ;
  HDC         ScreenDC ;
  LogPal      Palette = { 0x300, 256 } ;
  HPALETTE    ScreenPalette ;

  // Reset everything in the system palette to black
  for (Counter = 0 ; Counter < 256 ; Counter++)
  {
    Palette.pe [Counter].peRed = 0 ;
    Palette.pe [Counter].peGreen = 0 ;
    Palette.pe [Counter].peBlue = 0 ;
    Palette.pe [Counter].peFlags = PC_NOCOLLAPSE ;
  }

  // Create, select, realize, deselect, and delete the palette
  ScreenDC = GetDC (NULL) ;
  ScreenPalette = CreatePalette ((LOGPALETTE *) &Palette) ;
  if (ScreenPalette)
  {
    ScreenPalette = SelectPalette (ScreenDC, ScreenPalette, FALSE) ;
    RealizePalette (ScreenDC) ;
    ScreenPalette = SelectPalette (ScreenDC, ScreenPalette, FALSE) ;
    DeleteObject (ScreenPalette) ;
  }
  ReleaseDC (NULL, ScreenDC) ;
}





// Originale
void cleanup_all (void)
{
  DeleteCriticalSection (&critical_section) ;

  display_cleanup () ;
  
  if (hPalApp)
    DeleteObject (hPalApp) ;
  
  if (ourIcon)
    DestroyIcon (ourIcon) ;
  
  //UnregisterClass( "render_window", hInstance);
}



int povray_main(LPSTR szCmdLine)
{
  
  if ((szCmdLine = preparse_commandline (szCmdLine)) != NULL)   /* cerca le opzioni di linea di comando tipiche di WIN */
  {
    parse_commandline (szCmdLine) ;  /* inizializza i valori di argc e argv con quelli dell'attuale linea di comando*/
    restore_command_line = TRUE ;
    strncpy (command_line, szCmdLine, sizeof (command_line) - 1) ;
  }

  detect_graphics_config () ;
    
  getHome () ;  /* Cerca nel registro di sistema il path di installazione dell'applicazione */
  if (HomePath [0] == '\0')
  {
    printf("ERROR : Cannot find Home entry in registry.\n\n"
           "This entry should have been set by the installation program.\n\n"
           "If you did not install using the correct installation procedure, please "
           "do this before running POV-Ray for Windows. Otherwise, consult the README.DOC "
           "file that should have accompanied this executable file.",
           "Critical Error");
    return (1) ;
  }
  if (HomePath [strlen (HomePath) - 1] != '\\')
    strcat (HomePath, "\\") ;
  strupr (HomePath) ;
  
  sprintf (EngineIniFileName, "%sINI", HomePath) ;  /* scrive sul file di debug il percorso dei files INI */
  strcat (EngineIniFileName, "\\"INIFILENAME) ;
  sprintf (DefaultRenderIniFileName, "%sRENDERER\\POVRAY.INI", HomePath) ;
  sprintf (RerunIniPath, "%sRENDERER\\RERUN\\", HomePath) ;
  sprintf (CurrentRerunFileName, "%sRENDERER\\RERUN\\CURRENT.INI", HomePath) ;
  sprintf (ToolIniFileName, "%sINI\\"TOOLFILENAME, HomePath) ;

  InitializeCriticalSection (&critical_section) ;

  render_requested = 0;
  exit_after_render = 1;
  if (argc > 1)
      printf ("Calling rendering engine with parameters '%s'\n", command_line) ;
  start_rendering (TRUE, !render_requested) ;
  if (exit_after_render)
    {
      cleanup_all () ;
      return (0) ;
    }
  

  return povray_return_code;
}


void ClearFiles(void)
{
	int i;
	char txtbuffer[DIR_SIZE];

	i = 0;
    while (FileTable[i][0])
	{
		DeleteFile(FileTable[i]);
		printf("File %s deleted.\n", FileTable[i]);
		i++;
	}
				
	i = 0;
	while (RequestArray[i].request_id)
	{
	   SetCurrentDirectory(MainWorkDir);
	   memset(txtbuffer, 0, DIR_SIZE);
	   _snprintf( txtbuffer, DIR_SIZE, "%s\\%u", MainWorkDir, RequestArray[i].request_id);
	   if (RemoveDirectory(txtbuffer)) printf("Directory \"%s\" deleted.\n", txtbuffer);
	   else printf("Couldn't delete directory \"%s\".\n", txtbuffer);

	   i++;
	}
	return;
}


DWORD WINAPI receiving_thread(SOCKET *s2)		/* Si mette in ascolto su una socket s2, gi inizializzata e bound */
{
	struct sockaddr_in from_host;
	int size = sizeof(struct sockaddr_in);
	int nread = 0;
	int MustStay = 1;
	PACKET outgoing_packet,incoming_packet;
	fd_set rec_sock;
	struct timeval Timeout;
	int TIMEOUT = 0;
	int i=0;
	

	
    memset( (char *) &master_address, 0, sizeof(struct sockaddr_in));

	do
	{
		memset( &incoming_packet,0,sizeof(incoming_packet));
		memset( (char *) &from_host, 0, sizeof(struct sockaddr_in));


		rec_sock.fd_count = 1;
		rec_sock.fd_array[0] = *s2;
		Timeout.tv_sec = 30;
		Timeout.tv_usec = 0;
		while ((!select( 0,  &rec_sock, NULL, NULL, &Timeout))  )
		{
		   // Se sono qui allora  scaduto il time-out e rimando per n volte l'ultimo pacchetto
		   if (master_address.sin_family)              //ovviamente trasmetto al coordinatore solo se ne ho trovato uno
		   {
			   TIMEOUT ++;
				if (TIMEOUT > 2) printf("Coordinator time-out.\n");
				memset(&outgoing_packet, 0, PACKETSIZE);
				outgoing_packet.command = AREYOUALIVE_COMMAND;
	   			sendto(udp_sock, (char *) &outgoing_packet, PACKETSIZE, 0, (struct sockaddr *) &master_address, sizeof(struct sockaddr_in) );
		   }
		}
		TIMEOUT = 0;
		
		nread = recvfrom(*s2, (char *) &incoming_packet, sizeof(incoming_packet), 0, (struct sockaddr *) &from_host, &size );
		TIMEOUT = 0;
		if (nread<0)
		{
			printf("Errore %d su recvfrom\n", WSAGetLastError() );
			MustStay = 0;
			/* Rispedire l'ultimo pacchetto inviato */
		}

		switch (incoming_packet.command)
		{
		case CALLFORSLAVES_COMMAND:
			{
				if ((!coord_found) /*&& (!protocol_stage)*/)
				{
					coord_found = 1;
					memset(&master_address, 0, sizeof(struct sockaddr_in));
					from_host.sin_port = COORD_UDP_PORT;
					memcpy(&master_address, &from_host, sizeof(struct sockaddr_in) );
				
					memset(&outgoing_packet, 0, PACKETSIZE);
					outgoing_packet.command = ADDNODE_COMMAND;
					memcpy(&outgoing_packet.data, &Power, sizeof(Power) );
					Wait(LastPacketsMutex);	memcpy(&LastSentPacket, &outgoing_packet,PACKETSIZE);Signal(LastPacketsMutex);
					
				
					Wait(ConsoleMutex); printf("Found Coordinator %s, sending reply...", inet_ntoa(master_address.sin_addr));
					sendto(*s2, (char *) &outgoing_packet, PACKETSIZE, 0, (struct sockaddr *) &master_address, sizeof(struct sockaddr_in));
					printf("reply sent.\n"); Signal(ConsoleMutex);
					SetEvent(MasterFound);
				}
				break;
			}
		case DELETENODE_COMMAND:
			{
				SlaveMustContinue = 0;
				break;
			}
		case SLAVEQUIT_COMMAND:
		case SLAVEKILL_COMMAND:
			{
				if ((!coord_found) || (coord_found && ( from_host.sin_addr.s_addr != master_address.sin_addr.s_addr) )) break;
				// se i messaggi non me li manda il mio coordinatore li ignoro
				
				if (RenderingInEsecuzione) Stop_Flag = 1;
				while (RenderingInEsecuzione) ;
				
				// devo cancellare tutti i files e anche l'indirizzo del master
				ClearFiles();
				
				memset( (char *) &master_address, 0, sizeof(struct sockaddr_in));
				coord_found = 0;

				memset(&LastReceivedPacket, 0, PACKETSIZE);
				LastReceivedPacket_id = 0;
				
				if (incoming_packet.command == SLAVEQUIT_COMMAND) SetEvent(h[1]);
				else {
						WSACleanup();
						ExitProcess(1);
					}

				break;
			}

		case SLAVESTOP_COMMAND:
			{
				if ((!coord_found) || (coord_found && ( from_host.sin_addr.s_addr != master_address.sin_addr.s_addr) )) break;
				// se i messaggi non me li manda il mio coordinatore li ignoro

				Stop_Flag = TRUE;
				RenderingFermato = 1;
				break;
			}

		case IAMALIVE_COMMAND:
			{
				if ((!coord_found) || (coord_found && ( from_host.sin_addr.s_addr != master_address.sin_addr.s_addr) )) break;
				// se i messaggi non me li manda il mio coordinatore li ignoro

				//SetEvent(MasterAlive_Event);
				break;
			}

		case AREYOUALIVE_COMMAND:
			{
				// a chi mi chiede se sono vivo rispondo di si
				memset(&outgoing_packet, 0, PACKETSIZE);
				outgoing_packet.command = IAMALIVE_COMMAND;
				from_host.sin_port = COORD_UDP_PORT;
				
				sendto(*s2, (char *) &outgoing_packet, PACKETSIZE, 0, (struct sockaddr *) &from_host, sizeof(struct sockaddr_in));
				
				break;
			}

		default :
			{
				if (incoming_packet.datagram_id <= LastReceivedPacket_id)
					sendto(*s2, (char *) &LastSentPacket, PACKETSIZE, 0, (struct sockaddr *) &master_address, sizeof(struct sockaddr_in));
				else
				{
					/*  arrivato un messaggio con una nuova ID */
					Wait(LastPacketsMutex);	memcpy(&LastReceivedPacket, &incoming_packet, PACKETSIZE); Signal(LastPacketsMutex);
					LastReceivedPacket_id = LastReceivedPacket.datagram_id;
					SetEvent(ExpectedPacketArrived);
				}
				break;
			}
		}
			

		
	
	} while( /*strcmp(incoming_packet.data,"stop") &&*/ MustStay);

	ExitThread(0);
	return 0;
}



float fib(float n)
{
	int i;
	float res;

	i = (int) floor(n);

	if ((i == 0) || (i == 1))
		res = 1;
	else res = fib(i-1)+fib(i-2);
	
	return res;
}


#define PIXELS_REF 120000.0
#define TIME_REF 72.0

#define PIXELSPERSEC_REF (PIXELS_REF / TIME_REF)
#define PIXELPERPOWERUNITPERSEC (PIXELSPERSEC_REF / 50000) 

time_t GetComputingPower(void)
{
	int i,j,k;
	float f[256];
	float flops,pps;
	time_t cp;
	LARGE_INTEGER freq, ti, tf, count;

	srand( (unsigned)time( NULL ) );

	for (i=0;i<256;i++) f[i] = 1000 * rand()/RAND_MAX;
	
	
	QueryPerformanceFrequency( &freq );
	
	QueryPerformanceCounter( &ti );
	
	for (k=0; k<2; k++)
	{
	  for (j = 0; j<256; j++)
	  {
		for (i = 0; i<256; i++)
		{
			f[j] = f[j] * f[i] + f[k];
			f[j] += f[ (i+64)%256 ] / ( abs(f[(i+128)%256]) < 0.1 ? 1 : f[ (i+128)%256] ) + f[k];
			f[j] += sqrt(f[ (i+172)%256]) + f[k];
			f[j] += tan(f[ (i+212)%256]) + f[k];
		}
	  }
	  f[k] = fib( 25 + k );
	}

	QueryPerformanceCounter( &tf );
	count.QuadPart = tf.QuadPart -ti.QuadPart;

	flops = (float) freq.QuadPart/ (float) count.QuadPart ;
	flops = flops * (i * j * k);

	pps = flops * PIXELPERPOWERUNITPERSEC;

	cp = (time_t) floor(pps);
	return cp;
}




int AlreadyProcessed(int req_id)
{
	int i = 0;

	while (i<MAX_REQUEST)
	{
		if (ProcessedRequestArray[i]==req_id) return 1;
		i++;
	}
	
	return 0;
}


char *GetFileName(char *fullname)
{
	char *c;

	c = fullname + strlen(fullname);

	while (*c != '\\')
	{
		if (c==fullname) break;
		c--;
	}
	c++;
	return c;
}

BOOL GestoreSegnali(DWORD fdwCtrlType) 
{ 
    PACKET p;

	switch (fdwCtrlType) 
    { 
        case CTRL_C_EVENT: 
		case CTRL_BREAK_EVENT: 
        case CTRL_CLOSE_EVENT: 
			printf("Close event detected, shutting down gracefully.");

			if (coord_found)
			{
				memset(&p,0,PACKETSIZE); p.command = SLAVEABORT_COMMAND;
				sendto(udp_sock, (char  *) &p, PACKETSIZE, 0, (struct sockaddr *) &master_address, sizeof(struct sockaddr_in) );
				closesocket(udp_sock);
				WSACleanup();
			}
            return FALSE; 
 
 
        // Pass other signals to the next handler. 
        
        case CTRL_LOGOFF_EVENT: 
        case CTRL_SHUTDOWN_EVENT: 
        default: 
            return FALSE; 
    } 
} 
 

	   


int main()
{
   int thread_id;
	
   struct hostent *localhost;
   int retval;
   struct sockaddr_in la,ra, la_tcp, connection_address;
   int connection_size;
   PACKET p;
   BOOL fBrCast;

   WORD wVersionRequested; 
   WSADATA wsaData; 
   int err;
   int data_pointer = 0;
   int file_no,len;
   fd_set socketarray;
   struct timeval Timeout;
   int tx_count = 0;
   int nread = 0;
   int nread_tot = 0;
   int i;
   char CurrentDir[DIR_SIZE];
   char OldDir[DIR_SIZE];
   int ft_index;
   BOOL fSuccess; 


   
   char txtbuffer[DIR_SIZE];
   char commandline[CMDLINE_SIZE];

   int ExitStatus = 0, a,b,n;
   
   WNDCLASS wc;


  SetConsoleTitle("dPoV - Distributed PoV [SLAVE MODULE] - Console Output");

  printf("\ndPoV - Distributed Persistence of Vision Ray Tracer\t   by Aldo Romani, 2001\n");
  printf("===================================================\n");
  printf("SLAVE MODULE.\nCode based on Persistence of Vision Raytracer(tm)\n[Copyright 1996-1999 Persistence of Vision Team]\n");
  printf("* This work is based on the free distribution code, and is freely available too\n");
  printf("* The new code implements support for network load sharing and balancing \n");
  printf("* The terms POV-Ray, POV, and Persistence of Vision Raytracer are trademarks\n* of the Persistence of Vision Team.\n\n");
 

   
  hInstance = GetModuleHandle(NULL);


  wc.style         = CS_BYTEALIGNCLIENT /*| CS_VREDRAW | CS_HREDRAW;*/;
  wc.lpfnWndProc   = Render_Window_Procedure ;
  wc.cbClsExtra    = 0 ;
  wc.cbWndExtra    = 0 ;
  wc.hInstance     = hInstance ;
  wc.hIcon         = NULL ;
  wc.hCursor       = LoadCursor (NULL, IDC_CROSS) ;
  wc.hbrBackground = /*NULL ;*/ (HBRUSH) GetStockObject(BLACK_BRUSH);
  wc.lpszMenuName  = NULL ;
  wc.lpszClassName = "render_window" ;
  if (RegisterClass (&wc) == FALSE)
    return (FALSE) ;


   ConsoleMutex = CreateMutex(NULL, FALSE, NULL);
   MasterFound = CreateEvent(NULL, FALSE, FALSE, NULL);
   ExpectedPacketArrived = CreateEvent(NULL, FALSE, FALSE, NULL);
   MasterAlive_Event = CreateEvent(NULL, FALSE, FALSE, NULL);
   
   LastPacketsMutex = CreateMutex(NULL, FALSE, NULL);
   h[0] = ExpectedPacketArrived;
   h[1] = CreateEvent(NULL, FALSE, FALSE, NULL);
   h[2] = MasterAlive_Event;

   memset(&LastReceivedPacket, 0, PACKETSIZE);
   memset(&LastSentPacket, 0, PACKETSIZE);
   memset(&RequestArray, 0, sizeof(RequestArray) );
   memset(&fullReqArr, 0, sizeof(fullReqArr) );
   memset(&Job, 0, sizeof(Job));
   memset(FileTable, 0, sizeof(FileTable));
   memset(FileSize, 0, sizeof(FileSize));
   memset(FileDescriptor, 0, sizeof(FileDescriptor));
   memset(ProcessedRequestArray,0,sizeof(ProcessedRequestArray) );
   memset(MainBuffer,0,sizeof(MainBuffer) );
   memset(commandline,0,CMDLINE_SIZE );
   memset(MainWorkDir,0,DIR_SIZE );


   GetCurrentDirectory(DIR_SIZE-1, MainWorkDir);

 
   printf("Benchmarking CPU speed...");
   Power = GetComputingPower();
   printf("Done!\n Pps = %d\n", Power);
   //Power = Power / 10000;
   //printf(" rounded to %d\n", Power);
   
   

   printf("Starting Windows Sockets...");
   wVersionRequested = MAKEWORD(1, 1); 
   err = WSAStartup(wVersionRequested, &wsaData); 
   if (err != 0)
   {
	   printf("error!\n");
	   return 0; 
   }
   printf("done!\n");
 
   
   printf("Creating UDP socket...");
   gethostname(localhostname,255);
   localhost = gethostbyname(localhostname);

   memset( (char*) &la, 0, sizeof(struct sockaddr_in));
   la.sin_family = AF_INET;
   la.sin_port = SLAVE_UDP_PORT;
   la.sin_addr.s_addr = /*INADDR_ANY*/ ( (struct in_addr *)(localhost->h_addr))->s_addr;

   udp_sock = socket(AF_INET, SOCK_DGRAM, 0);
   if (udp_sock==INVALID_SOCKET)
      {
         perror("socket");
         exit(2);
      }

   fBrCast = TRUE;
   err = setsockopt(udp_sock, SOL_SOCKET, SO_BROADCAST, (char *) &fBrCast, sizeof(BOOL) );

   retval = bind( udp_sock, (struct sockaddr *) &la, sizeof(struct sockaddr_in));
   if (retval!=0)
      {
         perror("bind");
         exit(1);
      }
   printf("done!\n");

   
   
   
   tcp_sock = socket(AF_INET, SOCK_STREAM, 0);
   if (tcp_sock==INVALID_SOCKET)
      {
         perror("socket");
         exit(2);
      }
   memset( (char*) &la_tcp, 0, sizeof(struct sockaddr_in));
   la_tcp.sin_family = AF_INET;
   la_tcp.sin_port = SLAVE_TCP_PORT;
   la_tcp.sin_addr.s_addr = /*INADDR_ANY*/ ( (struct in_addr *)(localhost->h_addr))->s_addr;
   retval = bind( tcp_sock, (struct sockaddr *) &la_tcp, sizeof(struct sockaddr_in));
   if (retval!=0)
   {
	   perror("bind");
	   exit(1);
   }
   listen(tcp_sock,1);
   

   printf("Installing signal handler...");
   fSuccess = SetConsoleCtrlHandler( (PHANDLER_ROUTINE) GestoreSegnali, TRUE);       
   if (! fSuccess) printf("error\nWARNING: Could not set control handler, slave may not quickly detect when we are gone becaues of a CTRL-C\n"); 
   else printf("done\n");



   Wait(ConsoleMutex); printf("Starting receiving thread on UDP port %d...", SLAVE_UDP_PORT);
   receiving_thread_udp = CreateThread(NULL, 0, receiving_thread, &udp_sock, 0, &thread_id);
   printf("done!\n"); Signal(ConsoleMutex);


   if (!coord_found)
   {
	   WaitForSingleObject(ConsoleMutex, INFINITE);
	   printf("Sending Network broadcast to find Coordinator...");
	   
	   memset( (char *) &ra, 0, sizeof(struct sockaddr_in));
	   ra.sin_family = AF_INET;
	   ra.sin_addr.s_addr = INADDR_BROADCAST;
	   ra.sin_port = COORD_UDP_PORT;

	   memset(&p, 0, sizeof(PACKET) );
       p.command = CALLFORMASTER_COMMAND;

	   sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   printf("sent!\n");
	   ReleaseMutex(ConsoleMutex);
   }

do
{


   while (WaitForSingleObject(MasterFound, 10000)==WAIT_TIMEOUT)
   {
	   // Timeout Action
	   tx_count++;
	   if (tx_count > 5)
	   {
		   printf("Can't find any coordinator...quitting.\n");
		   TerminateThread(receiving_thread, 0);
		   return 0;
	   }
   }

   
// Il loop comincia qui
do
{
   if (!SlaveMustContinue) /*return 0;*/ break;
   printf("Ready to serve new request, waiting for GETFILES command...\n");

   
   //WaitForSingleObject(ExpectedPacketArrived, INFINITE);
   // Aspetto un nuovo pacchetto o il segnale per uscire, se scatta il timeout mando un AREYOUALIVE e gestisco la risposta
   n = 2;
   tx_count = 0;
   ResetEvent(MasterAlive_Event);
   do
   {
	   err = WaitForMultipleObjects(n, h, FALSE, 30000);
	   
	   if (err == (WAIT_TIMEOUT))
	   {
		   n = 3;
		   tx_count++;

		   if (tx_count<2) { memset(&p, 0, sizeof(PACKET));  p.command = AREYOUALIVE_COMMAND; printf("Sending AREYOUALIVE command\n");
							 sendto( udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &master_address, sizeof(struct sockaddr_in)); }
	   }

	   if (err == (WAIT_OBJECT_0+2) )
	   {
		   tx_count = 0;
		   n = 2;
	   }

   } while ((err != WAIT_OBJECT_0) && (err!=(WAIT_OBJECT_0+1)) && (tx_count<2));

   if (err == (WAIT_OBJECT_0 + 1))
      break;

   if (tx_count >= 2)
   {
	   // devo cancellare tutti i files e anche l'indirizzo del master
	   ClearFiles();
	   
	   memset( (char *) &master_address, 0, sizeof(struct sockaddr_in));
	   coord_found = 0;

	   memset(&LastReceivedPacket, 0, PACKETSIZE);
	   LastReceivedPacket_id = 0;
	   break;
   }
   tx_count = 0;	   



   Wait(LastPacketsMutex);
   if (LastReceivedPacket.command != GETFILES_COMMAND)
   {
	   Signal(LastPacketsMutex);
	   Wait(ConsoleMutex);
	   printf("Protocol Error: client aborting\n");
	   Signal(ConsoleMutex);
	   memset(&p,0,PACKETSIZE);
	   p.command = SLAVEABORT_COMMAND;
	   
	   sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   
	   closesocket(udp_sock);
	   WSACleanup();
	   return 1;
   }

   /* a questo punto sono sicuro che il messaggio arrivato sia GETFILES */

   printf("Received GETFILES command.\n");
   memcpy(&Job.request_id, LastReceivedPacket.data, sizeof(int) );
   
   a = 0;
   while (fullReqArr[a]) a++;		//a  nella prima posizione vuota
   fullReqArr[a] = 1;
   memcpy(&RequestArray[a].request_id, LastReceivedPacket.data, sizeof(int) );

   file_no = LastReceivedPacket.data[4];
   data_pointer = 5;

   if (!AlreadyProcessed(Job.request_id) )
   {
   	   printf("Sending DONTHAVE command.\n");
	   memset(&p, 0, sizeof(PACKET) );
	   p.command = DONTHAVE_COMMAND;
	   p.datagram_id = LastReceivedPacket.datagram_id;
	   sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   memcpy(&LastSentPacket, &p, PACKETSIZE);

	   
	   // Devo creare una dir e copiare i files
	   memset(CurrentDir, 0, DIR_SIZE);
	   memset(OldDir, 0, DIR_SIZE);
	   memset(txtbuffer, 0, DIR_SIZE);
	   GetCurrentDirectory(DIR_SIZE, txtbuffer);
	   GetCurrentDirectory(DIR_SIZE, OldDir);
	   _snprintf( CurrentDir, DIR_SIZE, "%s\\%u", txtbuffer, Job.request_id);
	   printf("Creating directory %s.\n",CurrentDir);
	   CreateDirectory(CurrentDir, NULL);
 
		ft_index = 0;
		while (FileTable[ft_index][0]) ft_index++;

	   Wait(ConsoleMutex);
	   for (i=0;i<file_no;i++)
	   {
		   memcpy(&FileSize[i+ft_index], &LastReceivedPacket.data[data_pointer], sizeof(int));
		   data_pointer += sizeof(int);
	   
		   _snprintf(txtbuffer, DIR_SIZE, "%s\\%s", CurrentDir,GetFileName(&LastReceivedPacket.data[data_pointer] ));
		   printf("%d. %s\n",i,txtbuffer);
		   len = strlen( &LastReceivedPacket.data[data_pointer] );
		   strcpy( & FileTable[i+ft_index][0], txtbuffer );
		   data_pointer += len + 1;
	   }
	   Signal(ConsoleMutex);
	   Signal(LastPacketsMutex);


	   socketarray.fd_count = 1;
	   socketarray.fd_array[0] = tcp_sock;
	   Timeout.tv_sec = 15;
	   Timeout.tv_usec = 0;
	   tx_count = 1;
	   
	   while ((!select( 0,  &socketarray, NULL, NULL, &Timeout)) && (tx_count <= 3) )
	   {
		   // Se sono qui allora  scaduto il time-out e rimando per n volte l'ultimo pacchetto
		   tx_count++;
	   	   sendto(udp_sock, (char *) &LastSentPacket, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   }
	   
	   if (tx_count > 3) { Signal(LastPacketsMutex); Wait(ConsoleMutex); printf("Protocol Error: nobody connected to me\n"); Signal(ConsoleMutex);
						   memset(&p,0,PACKETSIZE); p.command = SLAVEABORT_COMMAND; sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
						   closesocket(udp_sock); WSACleanup(); return 1; }
	   
	   // Se sono qui allora vuol dire che ho una richiesta di connessione pendente
	   connection_size = sizeof(struct sockaddr_in);
	   ns = accept( tcp_sock, (struct sockaddr *)&connection_address, &connection_size);
	   socketarray.fd_array[0] = ns;

	   //Ora devo stare in attesa dei files
	   for (i = 0; i<file_no; i++)
	   {
		   printf("Now copying file %d [%s]\n",i, FileTable[i+ft_index]);
		   nread = 0; nread_tot = 0;
		   FileDescriptor[i] = open( FileTable[i+ft_index], _O_WRONLY | _O_CREAT | _O_BINARY, _S_IREAD | _S_IWRITE );
		   while (nread_tot < FileSize[i+ft_index] )
		   {
			   err = select(0, &socketarray, NULL, NULL, &Timeout);
			   if ((err == SOCKET_ERROR) || (err == 0))
			   {   Signal(LastPacketsMutex); Wait(ConsoleMutex); printf("Protocol Error: can't receive files\n"); Signal(ConsoleMutex);
				   memset(&p,0,PACKETSIZE); p.command = SLAVEABORT_COMMAND; sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
				   closesocket(udp_sock); WSACleanup(); return 1; }

			   nread = recv(ns, MainBuffer, ((FileSize[i+ft_index] - nread_tot) > MAINBUFFERSIZE ? MAINBUFFERSIZE : (FileSize[i+ft_index]-nread_tot)), 0 );
			   nread_tot += nread;
			   write( FileDescriptor[i], MainBuffer, nread );
		   }
	       close(FileDescriptor[i]);
	   }
	   //shutdown(ns, 0);
	   // Ora ho su disco i files che mi servono
   }
   else
   {
	   // Se ho gi i files apro lo stesso una connessione, in sola scrittura, per scrivere il contenuto del rendering
	   printf("Sending ALREADYHAVE command.\n");
	   memset(&p, 0, sizeof(PACKET) );
	   p.command = ALREADYHAVE_COMMAND;
	   p.datagram_id = LastReceivedPacket.datagram_id;
       sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   memcpy(&LastSentPacket, &p, PACKETSIZE);
	   Signal(LastPacketsMutex);

   
	   socketarray.fd_count = 1;
	   socketarray.fd_array[0] = tcp_sock;
	   Timeout.tv_sec = 15;
	   Timeout.tv_usec = 0;
	   tx_count = 1;
	   
	   while ((!select( 0,  &socketarray, NULL, NULL, &Timeout)) && (tx_count <= 3) )
	   {
		   // Se sono qui allora  scaduto il time-out e rimando per n volte l'ultimo pacchetto
		   tx_count++;
	   	   sendto(udp_sock, (char *) &LastSentPacket, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   }
	   if (tx_count > 3) { Signal(LastPacketsMutex); Wait(ConsoleMutex); printf("Protocol Error: nobody connected to me\n"); Signal(ConsoleMutex);
						   memset(&p,0,PACKETSIZE); p.command = SLAVEABORT_COMMAND; sendto(udp_sock, (char  *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
						   closesocket(udp_sock); WSACleanup(); return 1; }
	   connection_size = sizeof(struct sockaddr_in);
	   ns = accept( tcp_sock, (struct sockaddr *)&connection_address, &connection_size);

	   //shutdown(ns, 0);
   }

   // in entrambi i casi la socket  pronta a scrivere i dati del rendering.
   // Quindi devo far partire il rendering, e ad ogni linea devo scriverla sulla socket

   
   //WaitForSingleObject(ExpectedPacketArrived, INFINITE);
   //if (WaitForMultipleObjects(2, h, FALSE, INFINITE) == (WAIT_OBJECT_0 + 1)) break;
   // Aspetto un nuovo pacchetto o il segnale per uscire, se scatta il timeout mando un AREYOUALIVE e gestisco la risposta
   n = 2;
   tx_count = 0;
   ResetEvent(MasterAlive_Event);
   do
   {
	   err = WaitForMultipleObjects(n, h, FALSE, 30000);
	   
	   if (err == (WAIT_TIMEOUT))
	   {
		   n = 3;
		   tx_count++;

		   if (tx_count<2) { memset(&p, 0, sizeof(PACKET));  p.command = AREYOUALIVE_COMMAND; printf("Sending AREYOUALIVE command\n");
							 sendto( udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &master_address, sizeof(struct sockaddr_in)); }
	   }

	   if (err == (WAIT_OBJECT_0+2) )
	   {
		   tx_count = 0;
		   n = 2;
	   }

   } while ((err != WAIT_OBJECT_0) && (err!=(WAIT_OBJECT_0+1)) && (tx_count<2));

   if (err == (WAIT_OBJECT_0 + 1))
      break;

   if (tx_count >= 2)
   {
	   // devo cancellare tutti i files e anche l'indirizzo del master
	   ClearFiles();
	   memset( (char *) &master_address, 0, sizeof(struct sockaddr_in));
	   coord_found = 0;

	   memset(&LastReceivedPacket, 0, PACKETSIZE);
	   LastReceivedPacket_id = 0;
	   break;
   }
   tx_count = 0;	   


   Wait(LastPacketsMutex);
   if (LastReceivedPacket.command != STARTRENDERING_COMMAND)
   {
	   Signal(LastPacketsMutex);
	   Wait(ConsoleMutex);
	   printf("Protocol Error: was expecting STARTRENDERING command\n");
	   Signal(ConsoleMutex);
	   memset(&p,0,PACKETSIZE);
	   p.command = SLAVEABORT_COMMAND;
	   
	   sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   
	   closesocket(udp_sock);
	   WSACleanup();
	   return 1;
   }

   /* a questo punto sono sicuro che il messaggio arrivato sia STARTRENDERING */

   printf("Received STARTRENDERING command with parameters \"%s\".\n", LastReceivedPacket.data);
   Signal(LastPacketsMutex);

   strcpy(commandline, LastReceivedPacket.data);
   
   SetCurrentDirectory(CurrentDir);
   printf("Directory changed to %s\n",CurrentDir);
   NetworkSend = 1;
   printf("Starting rendering...\n");
   RenderingFermato = 0;
   
   RenderingInEsecuzione = 1;
   ErroreTrasferimentoBitmap = 0;
   ExitStatus = povray_main(commandline);
   RenderingInEsecuzione = 0;
   if (ErroreTrasferimentoBitmap)
   {
	   ErroreTrasferimentoBitmap = 0;
	   Signal(LastPacketsMutex); Wait(ConsoleMutex);
	   printf("Error while sending bitmap: slave aborting\n"); Signal(ConsoleMutex);
	   
	   memset(&p,0,PACKETSIZE); p.command = SLAVEABORT_COMMAND;
	   sendto(udp_sock, (char  *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
	   closesocket(udp_sock);
	   WSACleanup();
	   return 1;
   }

   printf("Rendering terminated...");
   SetCurrentDirectory(OldDir);
   printf("Directory changed back to to %s\n",OldDir);
   printf("Shutting down TCP connection...");
   //shutdown(ns,1);
   closesocket(ns);
   printf("done.\n");


   Wait(LastPacketsMutex);
   printf("Sending completion command.\n");
   memset(&p, 0, sizeof(PACKET) );
   if (!RenderingFermato) p.command = ( povray_return_code == 0 ? RENDERINGDONE_COMMAND : RENDERINGFAILED_COMMAND);
   else
   {
	   p.command = RENDERINGSTOPPED_COMMAND;
	   memcpy(&p.data, &ExitStatus, sizeof(ExitStatus) );
   }
   /*if (ExitStatus < 0) p.command = RENDERINGFAILED_COMMAND;*/


   p.datagram_id = LastReceivedPacket.datagram_id;
   sendto(udp_sock, (char *) &p, PACKETSIZE, 0, (struct sockaddr *) &ra, sizeof(struct sockaddr_in) );
   memcpy(&LastSentPacket, &p, PACKETSIZE);
   Signal(LastPacketsMutex);

   Stop_Flag = 0;
   RenderingFermato = 0;

   b = 0;
   while (ProcessedRequestArray[b]) b++;
   ProcessedRequestArray[b] = RequestArray[a].request_id;

   
   // Fine LOOP
}  while (SlaveMustContinue);



coord_found = 0;
SlaveMustContinue = 1;
printf("Quitting coordinator, waiting for a new one...\n");

} while (!MustQuit);


   WSACleanup();
   return 0;
}

   
   
   
   
   
   
   
   
   
   
   
  


